using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using UnityEngine.Events;

namespace CarMod
{
    public class CarMod
    {
        public static void Main()
        {
    //NSR Truck
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "NSR Truck",
                    NameToOrderByOverride = "MoreVehicles",
                    DescriptionOverride = "A small truck. Carry everything you want in it! Press the red button (F) at the back of the truck to change the texture. You can also click on the cabin and horn signal will play.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/NSR Truck.png"), 
                    AfterSpawn = (Instance) =>
                    {
                //Main
                        Sprite Mirror = ModAPI.LoadSprite("Textures/NSR Truck/Mirror.png");
                        Sprite CabinBackground = ModAPI.LoadSprite("Textures/NSR Truck/CabinBackground.png");
                        Sprite Wheel = ModAPI.LoadSprite("Textures/NSR Truck/Wheel.png");
                        Sprite GasTankSprite = ModAPI.LoadSprite("Textures/NSR Truck/Gas Tank.png");
                        Sprite Sign = ModAPI.LoadSprite("Textures/NSR Truck/BackStuff.png");
                        Sprite Fence = ModAPI.LoadSprite("Textures/NSR Truck/Fence.png");
                        Sprite BodyTop = ModAPI.LoadSprite("Textures/NSR Truck/BodyTop.png");
                        Sprite ButtonOff = ModAPI.LoadSprite("Textures/NSR Truck/ButtonOff.png");
                        Sprite ButtonOn = ModAPI.LoadSprite("Textures/NSR Truck/ButtonOn.png");

                        AudioClip Horn = ModAPI.LoadSound("Sfx/Truck Horn.mp3");
                        AudioClip ButtonOffSound = ModAPI.LoadSound("Sfx/ButtonOff.mp3");
                        AudioClip ButtonOnSound = ModAPI.LoadSound("Sfx/ButtonOn.mp3");

                        float MotorSpeed = -2500f;
                        bool WaterProof = false;
                        bool TextureBool = true;
                       
                        var body = Instance.transform.GetChild(0);
                        bool firstSpawn = (body.localPosition == Vector3.zero);                       
                        var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite1.Body = ModAPI.LoadSprite("Textures/NSR Truck/Body.png");
                        CarSprite1.Background = ModAPI.LoadSprite("Textures/NSR Truck/Background.png");
                        CarSprite1.FrontDoor = ModAPI.LoadSprite("Textures/NSR Truck/Door.png");
                        CarSprite1.Bonnet = ModAPI.LoadSprite("Textures/NSR Truck/Cabin.png");

                        
                        Instance.transform.GetChild(4).gameObject.SetActive(false);
                        Instance.transform.GetChild(6).gameObject.SetActive(false); //Back Door
                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingOrder = 5;
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().chosenIndex = UnityEngine.Random.Range(0, 3);
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[] 
                        {
                            CarSprite1
                        };                      
                //Settings
                    //GameObjects
                        Transform BodyFrame = Instance.transform.GetChild(0);
                        Transform frameBackground = BodyFrame.GetChild(0);
                        frameBackground.localPosition = new Vector3(0f, 0f);
                        Transform Cabine = Instance.transform.GetChild(3);
                        Transform door = Instance.transform.GetChild(5);                        

                        GameObject CabinBackgroundPart = new GameObject("Background");
                        CabinBackgroundPart.transform.parent = Cabine;
                        CabinBackgroundPart.transform.rotation = body.rotation;
                        CabinBackgroundPart.transform.localScale = Vector3.one; 
                        CabinBackgroundPart.transform.localPosition = new Vector3(0f, 0f);  
                        SpriteRenderer frameBackgroundRenderer = frameBackground.gameObject.GetComponent<SpriteRenderer>();
                        SpriteRenderer bodyBackgroundRenderer = CabinBackgroundPart.AddComponent<SpriteRenderer>();
                        bodyBackgroundRenderer.sprite = CabinBackground;
                        bodyBackgroundRenderer.sortingOrder = -1;
                        bodyBackgroundRenderer.sortingLayerName = "Background";

                        GameObject BackBodyTop = new GameObject("BackBodyTop");
                        BackBodyTop.transform.parent = BodyFrame;
                        BackBodyTop.transform.rotation = body.rotation;
                        BackBodyTop.transform.localScale = Vector3.one; 
                        BackBodyTop.transform.localPosition = new Vector3(0f, 0f); 
                        BackBodyTop.gameObject.SetActive(false); 
                        SpriteRenderer frameBackgroundRenderer2 = frameBackground.gameObject.GetComponent<SpriteRenderer>();
                        SpriteRenderer bodyBackgroundRenderer2 = BackBodyTop.AddComponent<SpriteRenderer>();
                        bodyBackgroundRenderer2.sprite = BodyTop;
                        bodyBackgroundRenderer2.sortingOrder = 9;
                        bodyBackgroundRenderer2.sortingLayerName = "Foreground";

                        if(firstSpawn)
                        {                                          
                            GameObject MirrorObject = new GameObject("Mirror");
                            MirrorObject.transform.parent = Instance.transform;
                            MirrorObject.transform.rotation = Cabine.rotation;
                            MirrorObject.transform.localScale = Vector3.one;
                            MirrorObject.transform.localPosition = new Vector3(4.3852f, 0.3145f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = MirrorObject;
                        
                            Cabine.localPosition = new Vector3(3.34286f, -0.1421f);
                            Cabine.gameObject.name = "Cabine";
                            //Cabine.gameObject.AddComponent<Optout>();
                            Instance.AddComponent<ObjectSerialisationHelper>();

                            door.localPosition = new Vector3(3.25715f, -0.08572f);
                            door.gameObject.name = "Door";
                            //door.gameObject.AddComponent<Optout>();
                            Instance.AddComponent<ObjectSerialisationHelper>();

                            BodyFrame.localPosition = Vector3.zero;
                            BodyFrame.gameObject.name = "Body";
                            //frame.gameObject.AddComponent<Optout>();
                            Instance.AddComponent<ObjectSerialisationHelper>();

                            GameObject BackButton = new GameObject("Button");
                            BackButton.transform.parent = Instance.transform;
                            BackButton.transform.rotation = Cabine.rotation;
                            BackButton.transform.localScale = Vector3.one;
                            BackButton.transform.localPosition = new Vector3(1.8727f, 1.69f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = BackButton;

                            GameObject SignPart = new GameObject("Sign");
                            SignPart.transform.parent = Instance.transform;
                            SignPart.transform.rotation = Cabine.rotation;
                            SignPart.transform.localScale = Vector3.one;
                            SignPart.transform.localPosition = new Vector3(-4.397f, -1.186f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = SignPart;

                            GameObject FencePart = new GameObject("Fence");
                            FencePart.transform.parent = Instance.transform;
                            FencePart.transform.rotation = Cabine.rotation;
                            FencePart.transform.localScale = Vector3.one;
                            FencePart.transform.localPosition = new Vector3(-0.9301103f, -1.25f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = FencePart;                      
                        }                                             
                    //Engine
                        var engine = Instance.transform.GetChild(7);
                        engine.localScale = new Vector3(0.9f, 0.9f);
                        if(firstSpawn)
                        {
                            engine.localPosition = new Vector3(2.924f, -0.967f);
                        }
                    //Gas Tank
                        var GasTank = Instance.transform.GetChild(8);
                        GasTank.localScale = new Vector3(0.9f, 0.9f);
                        if(firstSpawn)
                        {
                            GasTank.localPosition = new Vector3(1.331f, -1.304f);
                        }
                        //GameObject.Destroy(GasTank.gameObject.GetComponent<BoxCollider2D>());
                        Instance.transform.GetChild(8).gameObject.AddComponent<BoxCollider2D>();
                        Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sprite = GasTankSprite;
                        Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                    //0 Mirror
                        ObjectSerialisationHelper[] objectSerialisationHelpers = Instance.GetComponents<ObjectSerialisationHelper>();
                        objectSerialisationHelpers[0].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = Mirror;
                            chair1Renderer.sortingLayerName = "Foreground";
                            chair1Renderer.sortingOrder = -9;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            //chair1.AddComponent<BoxCollider2D>();
                            gameObject.AddComponent<Rigidbody2D>().mass = 1f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = Cabine.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.frequency = 8f;
                            fixedJoint.dampingRatio = 1f;
                            fixedJoint.breakForce = 500f;
                            fixedJoint.anchor = new Vector2(-0.0646f, -0.1862f);

                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            gameObject.AddComponent<PolygonCollider2D>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });                    
                    //1 Cabine
                        objectSerialisationHelpers[1].SerialisationObject = Cabine.gameObject;
                        objectSerialisationHelpers[1].InstantiateOverride = ((gameObject) =>
                        {        
                            AudioSource Audio;                
                            Audio = gameObject.AddComponent<AudioSource>();
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            gameObject.GetComponent<SpriteRenderer>().sortingOrder = 1;
                            PhysicalBehaviour phys = gameObject.GetComponent<PhysicalBehaviour>();
                            phys.TrueInitialMass = 10f;
                            phys.InitialMass = 10f;
                            phys.rigidbody.mass = 10f;
                            
                            FixedJoint2D fixedJoint = gameObject.GetComponent<FixedJoint2D>();
                            fixedJoint.breakForce = 10000f;
                            fixedJoint.breakTorque = 5000f;
                            HingeJoint2D hingeJoint = gameObject.GetComponent<HingeJoint2D>();
                            hingeJoint.anchor = new Vector2(0.684f, -1.007f);
                            hingeJoint.breakForce = 55000f;
                            hingeJoint.breakTorque = 50000f;
                            gameObject.GetComponent<HingeJoint2D>().limits = new JointAngleLimits2D()
                            {
                                min = 0,
                                max = 70
                            };
                            gameObject.AddComponent<UseEventTrigger>().Action = () =>
                            {
                                Audio.PlayOneShot(Horn);
                            };
                            PolygonCollider2D collider2 = gameObject.GetComponent<PolygonCollider2D>();
                            collider2.pathCount = 3;
                            collider2.SetPath(0, new Vector2[]
                            {
                            new Vector2(-1.11428571f,1.38571429f),
                            new Vector2(-1.11236191f,-1.27085507f),
                            new Vector2(-0.890135646f,-1.26565695f),
                            new Vector2(-0.76744628f,-0.960015655f),
                            new Vector2(-0.508374691f,-0.7888937f),
                            new Vector2(-0.114546299f,-0.793051422f),
                            new Vector2(0.149471045f,-1.01612675f),
                            new Vector2(0.234630063f,-1.27028143f),
                            new Vector2(0.880298376f,-1.27227914f),
                            new Vector2(0.881875277f,-1.38399053f),
                            new Vector2(1.06211543f,-1.38571429f),
                            new Vector2(1.05519366f,-0.949432731f),
                            new Vector2(1.00119042f,-0.955974519f),
                            new Vector2(1.00331998f,-0.474181652f),
                            new Vector2(0.945303679f,0.3893345f),
                            new Vector2(0.34003675f,1.387519f)                            
                            });
                            collider2.SetPath(1, new Vector2[]
                            {
                            new Vector2(-0.139613867f,-0.616731524f),
                            new Vector2(0.20703125f,-0.854346931f),
                            new Vector2(0.370859623f,-1.0978142f),
                            new Vector2(0.780607879f,-1.10049677f),
                            new Vector2(0.771600485f,0.369089842f),
                            new Vector2(0.278885841f,1.21838367f),
                            new Vector2(-0.941098452f,1.21078706f),
                            new Vector2(-0.953560233f,-0.615295827f)                           
                            });
                            collider2.SetPath(2, new Vector2[]
                            {
                            new Vector2(-0.460375547f,0.787469387f),
                            new Vector2(-0.499092817f,0.985782266f),
                            new Vector2(-0.656153202f,0.975601912f),
                            new Vector2(-0.689359426f,0.536615252f),
                            new Vector2(-0.605263054f,-0.462465316f),
                            new Vector2(-0.492100239f,-0.469435483f),
                            new Vector2(-0.482424498f,-0.625815153f),
                            new Vector2(-0.035804987f,-0.680332422f),
                            new Vector2(-0.0310842991f,-0.477799356f),
                            new Vector2(0.0958461761f,-0.398417085f),
                            new Vector2(0.114688158f,-0.310526639f),
                            new Vector2(0.0358977318f,-0.242200285f),
                            new Vector2(-0.373823345f,-0.245897442f),
                            new Vector2(-0.513394475f,0.586770773f)                            
                            });
                        });
                    //2 Door
                        objectSerialisationHelpers[2].SerialisationObject = door.gameObject;
                        objectSerialisationHelpers[2].InstantiateOverride = ((gameObject) =>
                        {
                            gameObject.GetComponent<FixedJoint2D>().connectedBody = Cabine.gameObject.GetComponent<Rigidbody2D>();
                            gameObject.GetComponent<HingeJoint2D>().connectedBody = Cabine.gameObject.GetComponent<Rigidbody2D>();
                            gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                                new Vector2(-0.942857146f,1.2428571f),
                                new Vector2(-0.942857146f,-0.753494799f),
                                new Vector2(-0.0506865978f,-0.758813918f),
                                new Vector2(0.243927717f,-0.944491565f),
                                new Vector2(0.403524786f,-1.2477659f),
                                new Vector2(0.942857146f,-1.2428571f),
                                new Vector2(0.942857146f,0.325659156f),
                                new Vector2(0.393956035f,1.23979867f)
                            });

                            //gameObject.AddComponent<Optout>();
                        }); 
                    //3 Body
                        objectSerialisationHelpers[3].SerialisationObject = BodyFrame.gameObject;
                        objectSerialisationHelpers[3].InstantiateOverride = ((gameObject) =>
                        {
                            //CarBehaviour beh = BodyFrame.gameObject.GetComponent<CarBehaviour>();
                            //beh.EngineStartup = ModAPI.LoadSound("Sfx/Startup.mp3");
                            //beh.EngineShutoff = ModAPI.LoadSound("Sfx/Shutoff.mp3");
                            //beh.EngineLoop = ModPI.LoadSound("Sfx/Loop.mp3");
                            gameObject.GetComponent<CarBehaviour>().MotorSpeed = MotorSpeed;
                            gameObject.GetComponent<CarBehaviour>().WaterProof = WaterProof;
                            gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                            gameObject.GetComponent<SpriteRenderer>().sortingOrder = -9;
                            PhysicalBehaviour phys = gameObject.GetComponent<PhysicalBehaviour>();
                            phys.TrueInitialMass = 30f;
                            phys.InitialMass = 30f;
                            phys.rigidbody.mass = 30f;
                            BoxCollider2D[] boxColliders = gameObject.GetComponents<BoxCollider2D>();
                            GameObject.Destroy(boxColliders[0]);
                            GameObject.Destroy(boxColliders[1]);
                            GameObject.Destroy(boxColliders[2]);
                            GameObject.Destroy(boxColliders[3]);
                            PolygonCollider2D collider1 = gameObject.GetComponent<PolygonCollider2D>();
                            collider1.pathCount = 1;
                            collider1.SetPath(0, new Vector2[]
                            {
                            new Vector2(1.94310784f,-0.780868173f),
                            new Vector2(-4.34571075f,-0.787746429f),
                            new Vector2(-4.34259987f,-0.588298619f),
                            new Vector2(-4.4570899f,-0.585916162f),                
                            new Vector2(-4.45713997f,-0.928539395f),
                            new Vector2(-4.30201387f,-0.928384066f),
                            new Vector2(-4.24242878f,-1.23972917f),
                            new Vector2(-3.49087548f,-1.38666177f),
                            new Vector2(-2.00902629f,-1.40035677f),
                            new Vector2(-1.43811643f,-1.34920585f),
                            new Vector2(-0.475689411f,-1.35996211f),
                            new Vector2(0.517740309f,-1.40930104f),
                            new Vector2(2.22149467f,-1.3153317f),
                            new Vector2(2.23236895f,-0.851729751f),
                            new Vector2(2.05511069f,-0.849445224f),
                            new Vector2(2.0552516f,1.93162251f),
                            new Vector2(-4.45638275f,1.92397475f),
                            new Vector2(-4.45960808f,1.7525394f),
                            new Vector2(-4.33928204f,1.75643778f),
                            new Vector2(-4.34375858f,1.8125f),
                            new Vector2(1.94651484f,1.81470776f)
                            });
                            //gameObject.AddComponent<Optout>();
                        });
                    //4 Button
                        objectSerialisationHelpers[4].InstantiateOverride = ((gameObject) =>
                        {
                            AudioSource Audio;                
                            Audio = gameObject.AddComponent<AudioSource>();
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = ButtonOff;
                            chair1Renderer.sortingLayerName = "Foreground";
                            chair1Renderer.sortingOrder = -8;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            //chair1.AddComponent<BoxCollider2D>();
                            gameObject.AddComponent<Rigidbody2D>().mass = 1f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            //fixedJoint.frequency = 8f;
                            //fixedJoint.dampingRatio = 1f;
                            //fixedJoint.breakForce = 500f;
                            //fixedJoint.anchor = new Vector2(-0.0646f, -0.1862f);

                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            gameObject.AddComponent<PolygonCollider2D>();

                            gameObject.AddComponent<UseEventTrigger>().Action = () =>
                            {
                                //Audio.PlayOneShot(BeepSound);

                                if (TextureBool)
                                {                                          
                                    TextureBool = !TextureBool;
                                    chair1Renderer.sprite = ButtonOn;
                                    BackBodyTop.gameObject.SetActive(true);
                                    Audio.PlayOneShot(ButtonOnSound);
                                }
                                else
                                {                                           
                                    TextureBool = !TextureBool;
                                    chair1Renderer.sprite = ButtonOff;
                                    BackBodyTop.gameObject.SetActive(false);
                                    Audio.PlayOneShot(ButtonOffSound);
                                }
                            };
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });  
                    //5 Sign
                        objectSerialisationHelpers[5].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = Sign;
                            chair1Renderer.sortingLayerName = "Foreground";
                            chair1Renderer.sortingOrder = -9;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            //chair1.AddComponent<BoxCollider2D>();
                            gameObject.AddComponent<Rigidbody2D>().mass = 1f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.frequency = 20f;
                            fixedJoint.dampingRatio = 5f;
                            fixedJoint.breakForce = 7000f;
                            fixedJoint.anchor = new Vector2(0.0262f, 0.2559f);

                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            gameObject.AddComponent<PolygonCollider2D>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        }); 
                    //6 Fence
                        objectSerialisationHelpers[6].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = Fence;
                            chair1Renderer.sortingLayerName = "Foreground";
                            chair1Renderer.sortingOrder = -9;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            //chair1.AddComponent<BoxCollider2D>();
                            gameObject.AddComponent<Rigidbody2D>().mass = 3f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.breakForce = 3500f;

                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            gameObject.AddComponent<PolygonCollider2D>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });  
                    //Wheels
                        WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        if(firstSpawn)
                        {
                            wheels[0].connectedBody.gameObject.transform.localPosition = new Vector2(3.0142f, -1.4865f);
                        }  
                        wheels[0].anchor = new Vector2(3.0142f, -1.4865f);
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel;
                        wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.4428571f;
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder = -2;
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
                        
                        if(firstSpawn)
                        {
                            wheels[1].connectedBody.gameObject.transform.localPosition = new Vector2(-2.8996f, -1.4865f);
                        }  
                        wheels[1].anchor = new Vector2(-2.8996f, -1.4865f);
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel;
                        wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.4428571f;  
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder = -2;
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Background";    
                    //SerialisationSettings
                        if(firstSpawn)
                        {
                            objectSerialisationHelpers[0].InstantiateOverride(objectSerialisationHelpers[0].SerialisationObject);
                            objectSerialisationHelpers[1].InstantiateOverride(objectSerialisationHelpers[1].SerialisationObject);
                            objectSerialisationHelpers[2].InstantiateOverride(objectSerialisationHelpers[2].SerialisationObject);
                            objectSerialisationHelpers[3].InstantiateOverride(objectSerialisationHelpers[3].SerialisationObject);
                            objectSerialisationHelpers[4].InstantiateOverride(objectSerialisationHelpers[4].SerialisationObject);
                            objectSerialisationHelpers[5].InstantiateOverride(objectSerialisationHelpers[5].SerialisationObject);
                            objectSerialisationHelpers[6].InstantiateOverride(objectSerialisationHelpers[6].SerialisationObject);
                        } 
                //                                   
                    }
                }
            );
    //Farm Truck
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Farm Truck",
                    NameToOrderByOverride = "MoreVehicles",
                    DescriptionOverride = "An ordinary farm truck. Carry whatever you want in it. Tomatoes, potatoes... Or mushrooms.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Farm Truck.png"), 
                    AfterSpawn = (Instance) =>
                    {
                    
                //Main
                        Sprite Chair = ModAPI.LoadSprite("Textures/Farm Truck/Chair.png");
                        Sprite BackBody = ModAPI.LoadSprite("Textures/Farm Truck/BackBody.png");
                        Sprite Wheel1 = ModAPI.LoadSprite("Textures/Farm Truck/Wheel.png");
                        float MotorSpeed = -1200f;
                        bool WaterProof = false;

                        var body = Instance.transform.GetChild(0);
                        bool firstSpawn = (body.localPosition == Vector3.zero);  

                        var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite1.Body = ModAPI.LoadSprite("Textures/Farm Truck/Body.png");
                        CarSprite1.Background = ModAPI.LoadSprite("Textures/Farm Truck/Background.png");
                        CarSprite1.FrontDoor = ModAPI.LoadSprite("Textures/Farm Truck/Door.png");
                        CarSprite1.BackDoor = ModAPI.LoadSprite("Textures/Farm Truck/Door.png");
                        CarSprite1.Bonnet = ModAPI.LoadSprite("Textures/Farm Truck/Bonnet.png");

                        var CarSprite2 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite2.Body = ModAPI.LoadSprite("Textures/Farm Truck/1/Body.png");
                        CarSprite2.Background = ModAPI.LoadSprite("Textures/Farm Truck/Background.png");
                        CarSprite2.FrontDoor = ModAPI.LoadSprite("Textures/Farm Truck/1/Door.png");
                        CarSprite2.BackDoor = ModAPI.LoadSprite("Textures/Farm Truck/Door.png");
                        CarSprite2.Bonnet = ModAPI.LoadSprite("Textures/Farm Truck/1/Bonnet.png");

                        var CarSprite3 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite3.Body = ModAPI.LoadSprite("Textures/Farm Truck/2/Body.png");
                        CarSprite3.Background = ModAPI.LoadSprite("Textures/Farm Truck/Background.png");
                        CarSprite3.FrontDoor = ModAPI.LoadSprite("Textures/Farm Truck/2/Door.png");
                        CarSprite3.BackDoor = ModAPI.LoadSprite("Textures/Farm Truck/Door.png");
                        CarSprite3.Bonnet = ModAPI.LoadSprite("Textures/Farm Truck/2/Bonnet.png");

                        var CarSprite4 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite4.Body = ModAPI.LoadSprite("Textures/Farm Truck/3/Body.png");
                        CarSprite4.Background = ModAPI.LoadSprite("Textures/Farm Truck/Background.png");
                        CarSprite4.FrontDoor = ModAPI.LoadSprite("Textures/Farm Truck/3/Door.png");
                        CarSprite4.BackDoor = ModAPI.LoadSprite("Textures/Farm Truck/Door.png");
                        CarSprite4.Bonnet = ModAPI.LoadSprite("Textures/Farm Truck/3/Bonnet.png");

                        var CarSprite5 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite5.Body = ModAPI.LoadSprite("Textures/Farm Truck/4/Body.png");
                        CarSprite5.Background = ModAPI.LoadSprite("Textures/Farm Truck/Background.png");
                        CarSprite5.FrontDoor = ModAPI.LoadSprite("Textures/Farm Truck/4/Door.png");
                        CarSprite5.BackDoor = ModAPI.LoadSprite("Textures/Farm Truck/Door.png");
                        CarSprite5.Bonnet = ModAPI.LoadSprite("Textures/Farm Truck/4/Bonnet.png");

                        var CarSprite6 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite6.Body = ModAPI.LoadSprite("Textures/Farm Truck/5/Body.png");
                        CarSprite6.Background = ModAPI.LoadSprite("Textures/Farm Truck/Background.png");
                        CarSprite6.FrontDoor = ModAPI.LoadSprite("Textures/Farm Truck/5/Door.png");
                        CarSprite6.BackDoor = ModAPI.LoadSprite("Textures/Farm Truck/Door.png");
                        CarSprite6.Bonnet = ModAPI.LoadSprite("Textures/Farm Truck/5/Bonnet.png");

                        var CarSprite7 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite7.Body = ModAPI.LoadSprite("Textures/Farm Truck/6/Body.png");
                        CarSprite7.Background = ModAPI.LoadSprite("Textures/Farm Truck/Background.png");
                        CarSprite7.FrontDoor = ModAPI.LoadSprite("Textures/Farm Truck/6/Door.png");
                        CarSprite7.BackDoor = ModAPI.LoadSprite("Textures/Farm Truck/Door.png");
                        CarSprite7.Bonnet = ModAPI.LoadSprite("Textures/Farm Truck/6/Bonnet.png");

                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingOrder = 5;
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().chosenIndex = UnityEngine.Random.Range(0, 7);
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[] 
                        {
                            CarSprite1,
                            CarSprite2,
                            CarSprite3,
                            CarSprite4,
                            CarSprite5,
                            CarSprite6,
                            CarSprite7
                        };                      
                //Settings
                        if(firstSpawn)
                        {
                            GameObject chair1 = new GameObject("Chair 1");
                            chair1.transform.parent = Instance.transform;
                            chair1.transform.localScale = Vector3.one;
                            chair1.transform.localPosition = new Vector3(1.378f, 0f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = chair1;

                            GameObject Bodyup = new GameObject("Body2");
                            Bodyup.transform.parent = Instance.transform;
                            Bodyup.transform.localScale = Vector3.one;
                            Bodyup.transform.localPosition = new Vector3(-1.35715f, 0.6425f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = Bodyup;

                            GameObject wheel = new GameObject("Wheel3");
                            wheel.transform.parent = Instance.transform;
                            wheel.transform.localScale = Vector3.one;
                            wheel.transform.localPosition = new Vector3(-2.6425f, -0.97258f); 
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = wheel;
                        }
                    //Body      
                        if (firstSpawn)
                        {
                            body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = MotorSpeed;
                            body.gameObject.GetComponent<CarBehaviour>().WaterProof = WaterProof; 
                        }                                       
                        body.GetComponent<PolygonCollider2D>().pathCount = 2;
                        body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-2.08656359f,-0.812196195f),
                            new Vector2(-1.88750386f,-0.814978123f),
                            new Vector2(-1.88553035f,-0.954497337f),
                            new Vector2(-1.8012439f,-0.956431568f),
                            new Vector2(-1.75943565f,-0.763816714f),
                            new Vector2(-1.61567426f,-0.565423787f),
                            new Vector2(-1.44711697f,-0.467139423f),
                            new Vector2(-1.20419812f,-0.470563561f),
                            new Vector2(-0.984296799f,-0.620107889f),
                            new Vector2(-0.876563311f,-0.811498523f),
                            new Vector2(-0.85886693f,-0.957251668f),
                            new Vector2(-0.770524383f,-0.955868006f),
                            new Vector2(-0.769501448f,-0.812644124f),
                            new Vector2(0.973743021f,-0.815095007f),
                            new Vector2(0.971589327f,-0.928107142f),
                            new Vector2(2.42784953f,-0.929102659f),
                            new Vector2(2.42788267f,-0.959282279f),
                            new Vector2(2.51180124f,-0.958982468f),
                            new Vector2(2.57525444f,-0.70948112f),
                            new Vector2(2.73817396f,-0.524995565f),
                            new Vector2(2.86546135f,-0.47456339f),
                            new Vector2(3.10405302f,-0.466497213f),
                            new Vector2(3.30040145f,-0.574766815f),
                            new Vector2(3.44424272f,-0.793358922f),
                            new Vector2(3.4604969f,-0.957581043f),
                            new Vector2(3.54375196f,-0.956652582f),
                            new Vector2(3.54327512f,-0.928254962f),
                            new Vector2(3.6854465f,-0.929162264f),
                            new Vector2(3.67338347f,-0.36817956f),
                            new Vector2(3.6276679f,0.104389921f),
                            new Vector2(3.53273654f,0.28174156f),
                            new Vector2(2.3133502f,0.503572345f),
                            new Vector2(1.89056778f,1.15553594f),
                            new Vector2(0.974596441f,1.15558827f),
                            new Vector2(0.969186306f,-0.12493062f),
                            new Vector2(-3.62919974f,-0.127284139f),
                            new Vector2(-3.62985754f,-0.529487073f),
                            new Vector2(-3.57203388f,-0.529364884f),
                            new Vector2(-3.57146907f,-0.813453972f),
                            new Vector2(-3.19982505f,-0.813750744f),
                            new Vector2(-3.20090556f,-0.958974242f),
                            new Vector2(-3.11605573f,-0.958111346f),
                            new Vector2(-3.06383252f,-0.727823257f),
                            new Vector2(-2.91824722f,-0.548275709f),
                            new Vector2(-2.73567557f,-0.469450176f),
                            new Vector2(-2.52478266f,-0.468540937f),
                            new Vector2(-2.34376001f,-0.570565999f),
                            new Vector2(-2.21173429f,-0.763200343f),
                            new Vector2(-2.17221069f,-0.957825363f),
                            new Vector2(-2.08662152f,-0.95648551f)                     
                        });
                        body.gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
                        {
                            new Vector2(1.06048715f,1.06935167f),
                            new Vector2(1.85266066f,1.07324696f),
                            new Vector2(2.25303102f,0.454822153f),
                            new Vector2(2.25688529f,-0.842599511f),
                            new Vector2(1.05610156f,-0.842598021f)
                        });
                        Instance.transform.GetChild(0).GetChild(0).localPosition = Vector3.zero;
                        foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            {
                                GameObject.Destroy(boxCollider);
                            }
                    
                    //Front Door
                        var frontDoor = Instance.transform.GetChild(5);                       
                        if(firstSpawn)
                        {
                            frontDoor.localPosition = new Vector3(1.6572f, 0.1143f);
                        }
                        Instance.transform.GetChild(5).gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.628571451f,0.985714316f),
                            new Vector2(-0.628571451f,-0.985714316f),
                            new Vector2(0.628571451f,-0.985714316f),
                            new Vector2(0.628571451f,0.353969574f),
                            new Vector2(0.195617408f,0.984531164f)
                        });
                        Instance.transform.GetChild(5).gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
                        {
                            new Vector2(-0.546772003f,0.89455688f),
                            new Vector2(-0.546869874f,0.357500613f),
                            new Vector2(0.518738389f,0.353141069f),
                            new Vector2(0.170083523f,0.898250222f)
                        });
                        frontDoor.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.627f, 0f);
                        frontDoor.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 6;
                        frontDoor.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                    //Back Door
                        var backDoor = Instance.transform.GetChild(6);
                        if(firstSpawn)
                        {
                            backDoor.localPosition = new Vector3(2.4285f, 0.12855f);
                        }
                        backDoor.gameObject.AddComponent<BoxCollider2D>().size = new Vector2(0.6285715f, 2.457143f);
                        backDoor.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.33f, 0f);
                        GameObject.Destroy(backDoor.gameObject.GetComponent<PolygonCollider2D>());
                        Instance.transform.GetChild(6).gameObject.SetActive(false);
                    //Bonnet
                        var bonnet = Instance.transform.GetChild(3);
                        //bonnet.gameObject.GetComponent<SpriteRenderer>().sortingOrder = wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        bonnet.gameObject.GetComponent<FixedJoint2D>().breakForce = 300f;
                        bonnet.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.5266f, 0.0997f);
                        var limits = new JointAngleLimits2D();
                        limits.min = -55;
                        limits.max = 0;
                        bonnet.gameObject.GetComponent<HingeJoint2D>().limits = limits;
                        if(firstSpawn)
                        {
                            bonnet.localPosition = new Vector3(2.9571f, 0.372f);
                        }
                        bonnet.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.557142854f,0.128571436f),
                            new Vector2(-0.556762457f,0.0727164745f),
                            new Vector2(0.557142854f,-0.128571436f),
                            new Vector2(0.554968238f,-0.0719154179f)
                        });                       
                    //Boot
                        Instance.transform.GetChild(4).gameObject.SetActive(false);
                    //Engine
                        var engine = Instance.transform.GetChild(7);
                        engine.localScale = new Vector3(0.9f, 0.9f);
                        if(firstSpawn)
                        {
                            engine.localPosition = new Vector3(2.899f, -0.068f);
                        }
                    //Gas Tank
                        var GasTank = Instance.transform.GetChild(8);
                        GasTank.localScale = new Vector3(0.9f, 0.9f);
                        if(firstSpawn)
                        {
                            GasTank.localPosition = new Vector3(0.1f, -0.781f);
                        }
                        GameObject.Destroy(GasTank.gameObject.GetComponent<BoxCollider2D>());
                        Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vechicle/Farm Truck/Gas Tank.png");
                        Instance.transform.GetChild(8).gameObject.AddComponent<BoxCollider2D>();
                        Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
                    //Chair
                        ObjectSerialisationHelper[] objectSerialisationHelpers = Instance.GetComponents<ObjectSerialisationHelper>();
                        objectSerialisationHelpers[0].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = Chair; 
                            chair1Renderer.sortingLayerName = "Foreground";
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            //gameObject.AddComponent<BoxCollider2D>();
                            gameObject.AddComponent<Rigidbody2D>().mass = 1f;
                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.breakForce = 4000f;
                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(-0.168023795f,0.821670711f),
                            new Vector2(-0.344577432f,0.844228387f),
                            new Vector2(-0.394698739f,0.401962787f),
                            new Vector2(-0.324890971f,-0.583773851f),
                            new Vector2(-0.187942624f,-0.686135948f),
                            new Vector2(-0.155961812f,-0.842857003f),
                            new Vector2(0.174404263f,-0.841987014f),
                            new Vector2(0.175086021f,-0.616229057f),
                            new Vector2(0.387412786f,-0.474665761f),
                            new Vector2(0.325327039f,-0.383610427f),
                            new Vector2(-0.0948002636f,-0.384580165f)                     
                            });
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });
                    //Back Body
                        objectSerialisationHelpers[1].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer BodyupRenderer = gameObject.AddComponent<SpriteRenderer>();
                            BodyupRenderer.sprite = BackBody;
                            BodyupRenderer.sortingLayerName = "Bubbles";
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            gameObject.AddComponent<Rigidbody2D>().mass = 3f;
                            FixedJoint2D fixedJointBodyup = gameObject.AddComponent<FixedJoint2D>();
                            fixedJointBodyup.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                            fixedJointBodyup.breakForce = 10000f;
                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            var Body2Collider = gameObject.AddComponent<PolygonCollider2D>();
                            Body2Collider.pathCount = 1;
                            Body2Collider.SetPath(0, new Vector2[]
                            {
                                new Vector2(2.21330214f,0.769262075f),
                                new Vector2(2.21401429f,-0.715592742f),
                                new Vector2(-2.18568945f,-0.716740131f),
                                new Vector2(-2.1830821f,0.0586607456f),
                                new Vector2(-2.2705977f,0.0562762916f),
                                new Vector2(-2.27231479f,-0.771428585f),
                                    new Vector2(2.29827881f,-0.772294104f),
                            new Vector2(2.30118632f,0.769322038f)                 
                            });
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });
                    //Wheels
                        WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        if(firstSpawn)
                        {
                            wheels[0].connectedBody.gameObject.transform.localPosition = new Vector2(2.98579f, -0.97258f);
                        }  
                        wheels[0].anchor = new Vector2(2.98579f, -0.97258f);
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel1;
                        wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.4428571f;

                        wheels[1].anchor = new Vector2(-1.3284f, -0.97258f);                        
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel1;
                        wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.4428571f;
                        if(firstSpawn)
                        {
                            wheels[1].connectedBody.gameObject.transform.localPosition = new Vector2(-1.3284f, -0.97258f);
                        }
                        objectSerialisationHelpers[2].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer gameObjectRenderer = gameObject.AddComponent<SpriteRenderer>();
                            gameObjectRenderer.sprite = wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite;
                            gameObjectRenderer.sortingOrder = body.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            gameObject.AddComponent<CircleCollider2D>();
                            gameObject.AddComponent<Rigidbody2D>().mass = 1f;
                            WheelJoint2D wheelJoint = body.gameObject.AddComponent<WheelJoint2D>();
                            wheelJoint.connectedBody = gameObject.GetComponent<Rigidbody2D>();
                            wheelJoint.anchor = new Vector3(-2.6425f, -0.97258f);
                            wheelJoint.motor = wheels[0].motor;
                            wheelJoint.suspension = wheels[0].suspension;
                            wheelJoint.breakForce = wheels[0].breakForce;
                            wheelJoint.useMotor = true;
                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rubber");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            gameObject.AddComponent<Optout>();

                            if (body.gameObject.GetComponent<CarBehaviour>().WheelJoints.Length == 2)
                            {
                                List<WheelJoint2D> wheelList = body.gameObject.GetComponent<CarBehaviour>().WheelJoints.ToList();
                                wheelList.Add(wheelJoint);
                                body.gameObject.GetComponent<CarBehaviour>().WheelJoints = wheelList.ToArray();

                                List<bool> wheelStateList = body.gameObject.GetComponent<CarBehaviour>().WheelJointState.ToList();
                                wheelStateList.Add(true);
                                body.gameObject.GetComponent<CarBehaviour>().WheelJointState = wheelStateList.ToArray();
                            }
                            else if (wheelJoint)
                            {
                                List<WheelJoint2D> wheelList = body.gameObject.GetComponent<CarBehaviour>().WheelJoints.ToList();
                                wheelList[2] = wheelJoint;
                                body.gameObject.GetComponent<CarBehaviour>().WheelJoints = wheelList.ToArray();

                                List<bool> wheelStateList = body.gameObject.GetComponent<CarBehaviour>().WheelJointState.ToList();
                                wheelStateList[2] = true;
                                body.gameObject.GetComponent<CarBehaviour>().WheelJointState = wheelStateList.ToArray();
                            }
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });
                    //SerialisationSettings
                        if(firstSpawn)
                        {
                            objectSerialisationHelpers[0].InstantiateOverride(objectSerialisationHelpers[0].SerialisationObject);
                            objectSerialisationHelpers[1].InstantiateOverride(objectSerialisationHelpers[1].SerialisationObject);
                            objectSerialisationHelpers[2].InstantiateOverride(objectSerialisationHelpers[2].SerialisationObject);
                        } 
                //
                    }
                }
            );
    //Vintage Pickup
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Vintage Pickup",
                    NameToOrderByOverride = "MoreVehicles",
                    DescriptionOverride = "Vintage truck. Carry whatever you want in the back. And please close the hatch.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Vintage Pickup.png"), 
                    AfterSpawn = (Instance) =>
                    {
                //Main
                    //Body Sprites
                        Sprite BodyTwo = ModAPI.LoadSprite("Textures/Vintage Pickup/Body2.png");
                        Sprite Wheel = ModAPI.LoadSprite("Textures/Vintage Pickup/Wheel.png");
                    //Random Sprites
                        Sprite[] BodyTwoSprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Vintage Pickup/Body2.png"),
                            ModAPI.LoadSprite("Textures/Vintage Pickup/Green/Body2.png"),
                            ModAPI.LoadSprite("Textures/Vintage Pickup/Brown/Body2.png"),
                        };
                        Sprite[] HatchSprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Vintage Pickup/Trunk Hatch.png"),
                            ModAPI.LoadSprite("Textures/Vintage Pickup/Green/Trunk Hatch.png"),
                            ModAPI.LoadSprite("Textures/Vintage Pickup/Brown/Trunk Hatch.png"),
                        };

                        float MotorSpeed = -2500f; //-2500f
                        bool WaterProof = false;
                        float WeaponSize = 1.0f;

                        bool flipped = Instance.transform.localScale.x < 0f;
						Instance.transform.localScale = new Vector2(WeaponSize * (flipped ? -1f : 1f), WeaponSize);
                       
                        var body = Instance.transform.GetChild(0);
                        bool firstSpawn = (body.localPosition == Vector3.zero);                       
                        var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite1.Body = ModAPI.LoadSprite("Textures/Vintage Pickup/Body.png");
                        CarSprite1.Background = ModAPI.LoadSprite("Textures/Vintage Pickup/Background.png");
                        CarSprite1.FrontDoor = ModAPI.LoadSprite("Textures/Vintage Pickup/Door.png");
                        CarSprite1.Bonnet = ModAPI.LoadSprite("Textures/Vintage Pickup/Bonnet.png");

                        var CarSprite2 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite2.Body = ModAPI.LoadSprite("Textures/Vintage Pickup/Green/Body.png");
                        CarSprite2.Background = ModAPI.LoadSprite("Textures/Vintage Pickup/Background.png");
                        CarSprite2.FrontDoor = ModAPI.LoadSprite("Textures/Vintage Pickup/Green/Door.png");
                        CarSprite2.Bonnet = ModAPI.LoadSprite("Textures/Vintage Pickup/Green/Bonnet.png");

                        var CarSprite3 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite3.Body = ModAPI.LoadSprite("Textures/Vintage Pickup/Brown/Body.png");
                        CarSprite3.Background = ModAPI.LoadSprite("Textures/Vintage Pickup/Background.png");
                        CarSprite3.FrontDoor = ModAPI.LoadSprite("Textures/Vintage Pickup/Brown/Door.png");
                        CarSprite3.Bonnet = ModAPI.LoadSprite("Textures/Vintage Pickup/Brown/Bonnet.png");

                        
                        Instance.transform.GetChild(4).gameObject.SetActive(false);
                        Instance.transform.GetChild(6).gameObject.SetActive(false); //Back Door
                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingOrder = 5;
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().chosenIndex = UnityEngine.Random.Range(0, 3);
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[] 
                        {
                            CarSprite1,
                            CarSprite2,
                            CarSprite3
                        };                      
                //Settings                 
                    //GameObjects
                        Transform BodyFrame = Instance.transform.GetChild(0);
                        Transform frameBackground = BodyFrame.GetChild(0);
                        frameBackground.localPosition = new Vector3(0f, 0f);                  

                        GameObject BodyTwoSPart = new GameObject("Background");
                        BodyTwoSPart.transform.parent = BodyFrame;
                        BodyTwoSPart.transform.rotation = body.rotation;
                        BodyTwoSPart.transform.localScale = Vector3.one; 
                        BodyTwoSPart.transform.localPosition = new Vector3(0f, 0f);  
                        SpriteRenderer frameBackgroundRenderer = frameBackground.gameObject.GetComponent<SpriteRenderer>();
                        SpriteRenderer bodyBackgroundRenderer = BodyTwoSPart.AddComponent<SpriteRenderer>();
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().OnAfterChange = new UnityEvent();
                        BodyTwoSPart.AddComponent<RandomCarTextureChildBehaviour>().Sprites = BodyTwoSprites;
                        //bodyBackgroundRenderer.sprite = BodyTwo;
                        bodyBackgroundRenderer.sortingOrder = 7;
                        bodyBackgroundRenderer.sortingLayerName = "Foreground";

                        if(firstSpawn)
                        {                                          
                            BodyFrame.localPosition = Vector3.zero;
                            BodyFrame.gameObject.name = "Body";
                            //frame.gameObject.AddComponent<Optout>();
                            Instance.AddComponent<ObjectSerialisationHelper>(); 

                            GameObject HatchPart = new GameObject("Hatch");
                            HatchPart.transform.parent = Instance.transform;
                            HatchPart.transform.rotation = BodyFrame.rotation;
                            HatchPart.transform.localScale = Vector3.one;
                            HatchPart.transform.localPosition = new Vector3(-2.967f, -0.157f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = HatchPart;                   
                        }                                             
                    //0 Body
                        ObjectSerialisationHelper[] objectSerialisationHelpers = Instance.GetComponents<ObjectSerialisationHelper>();
                        objectSerialisationHelpers[0].SerialisationObject = BodyFrame.gameObject;
                        objectSerialisationHelpers[0].InstantiateOverride = ((gameObject) =>
                        {
                            //CarBehaviour beh = BodyFrame.gameObject.GetComponent<CarBehaviour>();
                            //beh.EngineStartup = ModAPI.LoadSound("Sfx/Startup.mp3");
                            //beh.EngineShutoff = ModAPI.LoadSound("Sfx/Shutoff.mp3");
                            //beh.EngineLoop = ModPI.LoadSound("Sfx/Loop.mp3");
                            gameObject.GetComponent<CarBehaviour>().MotorSpeed = MotorSpeed;
                            gameObject.GetComponent<CarBehaviour>().WaterProof = WaterProof;
                            gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            gameObject.GetComponent<SpriteRenderer>().sortingOrder = 5;
                            PhysicalBehaviour phys = gameObject.GetComponent<PhysicalBehaviour>();
                            phys.TrueInitialMass = 15f;
                            phys.InitialMass = 15f;
                            phys.rigidbody.mass = 15f;
                            BoxCollider2D[] boxColliders = gameObject.GetComponents<BoxCollider2D>();
                            GameObject.Destroy(boxColliders[0]);
                            GameObject.Destroy(boxColliders[1]);
                            GameObject.Destroy(boxColliders[2]);
                            GameObject.Destroy(boxColliders[3]);
                            PolygonCollider2D collider1 = gameObject.GetComponent<PolygonCollider2D>();
                            collider1.pathCount = 2;
                            collider1.SetPath(0, new Vector2[]
                            {
                            new Vector2(2.85526419f,-0.930820346f),
                            new Vector2(3.00170135f,-0.598134518f),
                            new Vector2(3.00502825f,0.0356935412f),
                            new Vector2(2.69627357f,-0.163579881f),
                            new Vector2(1.63785851f,-0.0129931197f),
                            new Vector2(1.66480207f,0.305818886f),
                            new Vector2(1.14037788f,1.23816311f),
                            new Vector2(-0.149903193f,1.23849773f),
                            new Vector2(-0.213276297f,0.215841651f),
                            new Vector2(-0.22051996f,-0.327417016f),
                            new Vector2(-3.00023508f,-0.329512477f),
                            new Vector2(-2.99662709f,-0.668191552f),
                            new Vector2(-2.50924659f,-0.924483538f)
                            });
                            collider1.SetPath(1, new Vector2[]
                            {
                            new Vector2(0.10535197f,1.13346052f),
                            new Vector2(1.02330375f,1.1297667f),
                            new Vector2(1.4846493f,0.295497179f),
                            new Vector2(1.4862591f,-0.75677067f),
                            new Vector2(0.635522127f,-0.753368855f),
                            new Vector2(0.634070039f,-0.562847376f),
                            new Vector2(0.782717824f,-0.502800941f),
                            new Vector2(0.725698471f,-0.324557215f),
                            new Vector2(0.322816044f,-0.324059904f),
                            new Vector2(0.210455745f,0.897625625f),
                            new Vector2(0.0867402256f,0.886726975f)
                            });
                        });
                    //1 Hatch
                        objectSerialisationHelpers[1].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            body.gameObject.GetComponent<RandomCarTextureBehaviour>().OnAfterChange = new UnityEvent();
                            gameObject.AddComponent<RandomCarTextureChildBehaviour>().Sprites = HatchSprites;
                            //chair1Renderer.sprite = BootSprite;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 1;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            gameObject.AddComponent<Rigidbody2D>().mass = 0.2f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.breakForce = 300f;
                            //fixedJoint.anchor = new Vector2(0.0993f, 0.782f);
                            //fixedJoint.frequency = 8f;
                            //fixedJoint.dampingRatio = 9f;  
                            HingeJoint2D hingeJoint = gameObject.AddComponent<HingeJoint2D>();
                            hingeJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            hingeJoint.anchor = new Vector2(0.01370001f, -0.2154f);
                            hingeJoint.breakForce = 5000f;
                            hingeJoint.breakTorque = 5000f;
                            hingeJoint.useMotor = true;
                            AudioSource Audio;                
                            Audio = gameObject.AddComponent<AudioSource>();

                            gameObject.GetComponent<HingeJoint2D>().limits = new JointAngleLimits2D()
                            {
                                min = 0,
                                max = -90
                            };
                            float BootSpeed = -0f; 
                            float BootTorque = 15f; 
                            bool OpenCloseBoot = true;
                            hingeJoint.motor = new JointMotor2D
                            {
                                maxMotorTorque = BootTorque,
                                motorSpeed = BootSpeed
                            };                                             
                            gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(-0.0571428575f,0.257142872f),
                            new Vector2(-0.0284725465f,-0.257142872f),
                            new Vector2(0.0571428575f,-0.257142872f),
                            new Vector2(0.0571428575f,0.257142872f)
                            });
                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });
                    //Bonnet
                        var bonnet = Instance.transform.GetChild(3);
                        bonnet.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        bonnet.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 7;
                        //bonnet.gameObject.GetComponent<SpriteRenderer>().sortingOrder = wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        bonnet.gameObject.GetComponent<FixedJoint2D>().breakForce = 500f;
                        bonnet.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.65f, 0.092f);
                        var limits = new JointAngleLimits2D();
                        limits.min = -65;
                        limits.max = 0;
                        bonnet.gameObject.GetComponent<HingeJoint2D>().limits = limits;
                        if(firstSpawn)
                        {
                            bonnet.localPosition = new Vector3(2.3f, 0.17f);
                        }
                        bonnet.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.671428561f,0.128571436f),
                            new Vector2(-0.669849753f,-0.0130094811f),
                            new Vector2(-0.616640329f,-0.0154280066f),
                            new Vector2(-0.60582912f,0.0690621138f),
                            new Vector2(0.575072527f,-0.0730053633f),
                            new Vector2(0.608204842f,-0.129942149f),
                            new Vector2(0.668270946f,-0.1317292f),
                            new Vector2(0.622482896f,-0.0439820401f)
                        });
                    //Engine
                        var engine = Instance.transform.GetChild(7);
                        engine.localScale = new Vector3(0.9f, 0.9f);
                        if(firstSpawn)
                        {
                            engine.localPosition = new Vector3(2.25f, -0.355f);
                        }
                    //Gas Tank
                        var GasTank = Instance.transform.GetChild(8);
                        GasTank.localScale = new Vector3(0.9f, 0.9f);
                        if(firstSpawn)
                        {
                            GasTank.localPosition = new Vector3(-0.795f, -0.633f);
                        }
                        //GameObject.Destroy(GasTank.gameObject.GetComponent<BoxCollider2D>());
                        Instance.transform.GetChild(8).gameObject.AddComponent<BoxCollider2D>();
                        //Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sprite = GasTankSprite;
                        Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
                    //Front Door
                        var frontDoor = Instance.transform.GetChild(5);
                        if(firstSpawn)
                        {
                            frontDoor.localPosition = new Vector3(0.7714076f, 0.1856998f);
                        }                       
                        Instance.transform.GetChild(5).gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.656511307f,0.967503726f),
                            new Vector2(-0.741649508f,0.427599728f),
                            new Vector2(-0.738792956f,-0.858775973f),
                            new Vector2(-0.626993179f,-0.962233007f),
                            new Vector2(0.630671442f,-0.964072108f),
                            new Vector2(0.736115575f,-0.854466915f),
                            new Vector2(0.735007584f,0.105849594f),
                            new Vector2(0.256511241f,0.963578999f)
                        });
                        frontDoor.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(0.698f, 0f);
                        frontDoor.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 6;
                        frontDoor.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground"; 
                    //Wheels
                        WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        if(firstSpawn)
                        {
                            wheels[0].connectedBody.gameObject.transform.localPosition = new Vector2(2.3285f, -0.8852f);
                            wheels[0].connectedBody.gameObject.transform.localScale = new Vector2(1.1f, 1.1f);
                        } 
                        wheels[0].suspension = new JointSuspension2D()
                        {
                            frequency = 5f,
                            angle = 90f,
                            dampingRatio = 0.7f
                        };
                        wheels[0].anchor = new Vector2(2.3285f, -0.8852f);
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel;
                        wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.3857143f;
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder = -2;
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
                        
                        if(firstSpawn)
                        {
                            wheels[1].connectedBody.gameObject.transform.localPosition = new Vector2(1.228f, -0.8727002f);
                            wheels[1].connectedBody.gameObject.transform.localScale = new Vector2(1.1f, 1.1f);
                        } 
                        wheels[1].suspension = new JointSuspension2D()
                        {
                            frequency = 5f,
                            angle = 90f,
                            dampingRatio = 0.7f
                        };
                        wheels[1].anchor = new Vector2(-1.871f, -0.8852f);
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel;
                        wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.3857143f;  
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder = -2;
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Background";    
                    //SerialisationSettings
                        if(firstSpawn)
                        {
                            objectSerialisationHelpers[0].InstantiateOverride(objectSerialisationHelpers[0].SerialisationObject);
                            objectSerialisationHelpers[1].InstantiateOverride(objectSerialisationHelpers[1].SerialisationObject);
                        } 
                //                                   
                    }
                }
            );
    //Van
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Van",
                    NameToOrderByOverride = "MoreVehicles",
                    DescriptionOverride = "Van for 3 people. There is room in the back for the necessary things. You can also open the side door by clicking on it (F).",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Van.png"), 
                    AfterSpawn = (Instance) =>
                    {
                //Main
                    //Sfx
                        AudioClip DoorSlide = ModAPI.LoadSound("Sfx/DoorSlide.mp3");
                        AudioClip Horn = ModAPI.LoadSound("Sfx/Truck Horn.mp3");
                    //Body Sprites
                        Sprite Wheel = ModAPI.LoadSprite("Textures/Van/Wheel.png");
                        Sprite BootSprite = ModAPI.LoadSprite("Textures/Van/Boot.png");
                        Sprite OpenSideDoorSprite = ModAPI.LoadSprite("Textures/Van/DoorBig2.png");
                        Sprite ClosedSideDoorSprite = ModAPI.LoadSprite("Textures/Van/DoorBig.png");
                        Sprite SteeringWheelSprite = ModAPI.LoadSprite("Textures/Van/SteeringWheel.png");
                    //Random Sprites
                        Sprite[] OpenSideDoorSprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Van/DoorBig2.png"),
                            ModAPI.LoadSprite("Textures/Van/LightGreen/DoorBig2.png"),
                        };
                        Sprite[] ClosedSideDoorSprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Van/DoorBig.png"),
                            ModAPI.LoadSprite("Textures/Van/LightGreen/DoorBig.png"),
                        };
                        Sprite[] BootSprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Van/Boot.png"),
                            ModAPI.LoadSprite("Textures/Van/LightGreen/Boot.png"),
                        };

                        float MotorSpeed = -2500f; //-2500f
                        float WeaponSize = 1.2f;
                        bool WaterProof = false;
                        bool TextureBool = true;

                        bool flipped = Instance.transform.localScale.x < 0f;
						Instance.transform.localScale = new Vector2(WeaponSize * (flipped ? -1f : 1f), WeaponSize);
                       
                        var body = Instance.transform.GetChild(0);
                        bool firstSpawn = (body.localPosition == Vector3.zero);                       
                        var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite1.Body = ModAPI.LoadSprite("Textures/Van/Body.png");
                        CarSprite1.Background = ModAPI.LoadSprite("Textures/Van/Background.png");
                        CarSprite1.FrontDoor = ModAPI.LoadSprite("Textures/Van/FrontDoor.png");
                        CarSprite1.Bonnet = ModAPI.LoadSprite("Textures/Van/Bonnet.png");

                        var CarSprite2 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite2.Body = ModAPI.LoadSprite("Textures/Van/LightGreen/Body.png");
                        CarSprite2.Background = ModAPI.LoadSprite("Textures/Van/Background.png");
                        CarSprite2.FrontDoor = ModAPI.LoadSprite("Textures/Van/LightGreen/FrontDoor.png");
                        CarSprite2.Bonnet = ModAPI.LoadSprite("Textures/Van/LightGreen/Bonnet.png");
                  
                        Instance.transform.GetChild(4).gameObject.SetActive(false);
                        Instance.transform.GetChild(6).gameObject.SetActive(false); //Back Door
                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingOrder = 5;
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().chosenIndex = UnityEngine.Random.Range(0, 2);
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[] 
                        {
                            CarSprite1,
                            CarSprite2,
                        };                      
                //Settings                 
                    //GameObjects
                        Transform BodyFrame = Instance.transform.GetChild(0);

                        if(firstSpawn)
                        {     
                            GameObject BootPart = new GameObject("Boot");
                            BootPart.transform.parent = Instance.transform;
                            BootPart.transform.rotation = BodyFrame.rotation;
                            BootPart.transform.localScale = Vector3.one;
                            BootPart.transform.localPosition = new Vector3(-3.5427f, 0.26f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = BootPart; 

                            BodyFrame.localPosition = Vector3.zero;
                            BodyFrame.gameObject.name = "Body";
                            //frame.gameObject.AddComponent<Optout>();
                            Instance.AddComponent<ObjectSerialisationHelper>(); 

                            GameObject SideDoorPart = new GameObject("Side Door");
                            SideDoorPart.transform.parent = Instance.transform;
                            SideDoorPart.transform.rotation = BodyFrame.rotation;
                            SideDoorPart.transform.localScale = Vector3.one; 
                            SideDoorPart.transform.localPosition = new Vector3(-0.01439f, 0.1428f);
                            //SideDoorPart.gameObject.SetActive(true); 
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = SideDoorPart; 

                            GameObject SteeringWheelPart = new GameObject("Steering Wheel");
                            SteeringWheelPart.transform.parent = Instance.transform;
                            SteeringWheelPart.transform.rotation = BodyFrame.rotation;
                            SteeringWheelPart.transform.localScale = Vector3.one; 
                            SteeringWheelPart.transform.localPosition = new Vector3(2.8135f, 0.3425f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = SteeringWheelPart;                 
                        }  
                    //0 Boot
                        ObjectSerialisationHelper[] objectSerialisationHelpers = Instance.GetComponents<ObjectSerialisationHelper>();
                        objectSerialisationHelpers[0].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            body.gameObject.GetComponent<RandomCarTextureBehaviour>().OnAfterChange = new UnityEvent();
                            gameObject.AddComponent<RandomCarTextureChildBehaviour>().Sprites = BootSprites;
                            //chair1Renderer.sprite = BootSprite;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 1;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            gameObject.AddComponent<Rigidbody2D>().mass = 0.2f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.breakForce = 300f; 
                            HingeJoint2D hingeJoint = gameObject.AddComponent<HingeJoint2D>();
                            hingeJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            hingeJoint.anchor = new Vector2(0.0993f, 0.782f);
                            hingeJoint.breakForce = 5000f;
                            hingeJoint.breakTorque = 5000f;
                            hingeJoint.useMotor = true;
                            AudioSource Audio;                
                            Audio = gameObject.AddComponent<AudioSource>();

                            gameObject.GetComponent<HingeJoint2D>().limits = new JointAngleLimits2D()
                            {
                                min = 0,
                                max = 120
                            };
                            float BootSpeed = -0f; 
                            float BootTorque = 8f; 
                            bool OpenCloseBoot = true;
                            hingeJoint.motor = new JointMotor2D
                            {
                                maxMotorTorque = BootTorque,
                                motorSpeed = BootSpeed
                            };  
                            /*gameObject.AddComponent<UseEventTrigger>().Action = () =>
                            {
                                if (OpenCloseBoot)
                                {                                          
                                    OpenCloseBoot = !OpenCloseBoot;
                                    BootSpeed = 15f;  
                                    BootTorque = 7f;             
                                    Audio.PlayOneShot(DoorSlide);
                                }
                                else
                                {                                           
                                    OpenCloseBoot = !OpenCloseBoot;
                                    BootSpeed = -15f;
                                    BootTorque = -7f;
                                    Audio.PlayOneShot(DoorSlide);
                                }
                                JointMotor2D motor = hingeJoint.motor;
                                motor.maxMotorTorque = BootTorque;
                                motor.motorSpeed = BootSpeed;
                            };     
                            */
                                                 
                            gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(0.143940926f,0.824017167f),
                            new Vector2(0.0545118377f,0.820781112f),
                            new Vector2(-0.0831313878f,0.0572116077f),
                            new Vector2(-0.0860362053f,-0.505003631f),
                            new Vector2(-0.14198184f,-0.541833818f),
                            new Vector2(-0.143734932f,-0.6005373f),
                            new Vector2(-0.0865507126f,-0.605960727f),
                            new Vector2(-0.0876985341f,-0.828571439f),
                            new Vector2(0.00454795733f,-0.828571439f),
                            new Vector2(0.00488830358f,0.0432980061f)
                            });
                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });                                           
                    //0 Body                       
                        objectSerialisationHelpers[1].SerialisationObject = BodyFrame.gameObject;
                        objectSerialisationHelpers[1].InstantiateOverride = ((gameObject) =>
                        {
                            //CarBehaviour beh = BodyFrame.gameObject.GetComponent<CarBehaviour>();
                            //beh.EngineStartup = ModAPI.LoadSound("Sfx/Startup.mp3");
                            //beh.EngineShutoff = ModAPI.LoadSound("Sfx/Shutoff.mp3");
                            //beh.EngineLoop = ModPI.LoadSound("Sfx/Loop.mp3");
                            gameObject.GetComponent<CarBehaviour>().MotorSpeed = MotorSpeed;
                            gameObject.GetComponent<CarBehaviour>().WaterProof = WaterProof;
                            gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            gameObject.GetComponent<SpriteRenderer>().sortingOrder = 2;
                            PhysicalBehaviour phys = gameObject.GetComponent<PhysicalBehaviour>();
                            phys.TrueInitialMass = 28f;
                            phys.InitialMass = 28f;
                            phys.rigidbody.mass = 28f;
                            BoxCollider2D[] boxColliders = gameObject.GetComponents<BoxCollider2D>();
                            GameObject.Destroy(boxColliders[0]);
                            GameObject.Destroy(boxColliders[1]);
                            GameObject.Destroy(boxColliders[2]);
                            GameObject.Destroy(boxColliders[3]);
                            PolygonCollider2D collider1 = gameObject.GetComponent<PolygonCollider2D>();
                            collider1.pathCount = 4;
                            collider1.SetPath(0, new Vector2[]
                            {
                            new Vector2(3.15691495f,-0.931653619f),
                            new Vector2(3.62546349f,-0.772631109f),
                            new Vector2(3.62074685f,0.168344378f),
                            new Vector2(2.86787462f,0.809890032f),
                            new Vector2(2.33458424f,1.17634201f),
                            new Vector2(1.83208358f,1.31062424f),
                            new Vector2(-2.57717991f,1.31108975f),
                            new Vector2(-3.44039559f,1.20598054f),
                            new Vector2(-3.44677162f,1.08520389f),
                            new Vector2(2.28238511f,1.08480334f),
                            new Vector2(3.10447192f,0.437182605f),
                            new Vector2(3.11116028f,-0.59101665f),
                            new Vector2(-3.62533212f,-0.589511573f),
                            new Vector2(-3.52640152f,-0.939671993f)
                            });
                            collider1.SetPath(1, new Vector2[]
                            {
                            new Vector2(0.222486973f,1.02349257f),
                            new Vector2(0.371715426f,-0.211736381f),
                            new Vector2(0.834664583f,-0.213941306f),
                            new Vector2(0.83528316f,-0.366983503f),
                            new Vector2(0.713599145f,-0.568572283f),
                            new Vector2(0.264045954f,-0.571894884f),
                            new Vector2(0.134879589f,-0.388427258f),
                            new Vector2(0.0875671506f,0.986581862f)
                            });
                            collider1.SetPath(2, new Vector2[]
                            {
                            new Vector2(-1.15413761f,0.980700254f),
                            new Vector2(-0.963344932f,0.99483037f),
                            new Vector2(-0.851079941f,-0.203779608f),
                            new Vector2(-0.347153604f,-0.202479377f),
                            new Vector2(-0.483695835f,-0.581460476f),
                            new Vector2(-0.93742311f,-0.580495834f),
                            new Vector2(-1.04854047f,-0.405968726f)
                            });
                            collider1.SetPath(3, new Vector2[]
                            {
                            new Vector2(2.49370933f,-0.361462563f),
                            new Vector2(2.49317122f,-0.213045105f),
                            new Vector2(2.03016782f,-0.1982878f),
                            new Vector2(1.90141118f,1.0178448f),
                            new Vector2(1.73807299f,1.02446342f),
                            new Vector2(1.77442002f,-0.43494615f)
                            });
                        });
                    //2 Side Door
                        objectSerialisationHelpers[2].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            body.gameObject.GetComponent<RandomCarTextureBehaviour>().OnAfterChange = new UnityEvent();
                            gameObject.AddComponent<RandomCarTextureChildBehaviour>().Sprites = ClosedSideDoorSprites;
                            //chair1Renderer.sprite = ClosedSideDoorSprite;
                            chair1Renderer.sortingLayerName = "Foreground";
                            chair1Renderer.sortingOrder = 5;
                            gameObject.layer = 10;
                            gameObject.AddComponent<Rigidbody2D>().mass = 0.1f;
                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            AudioSource Audio;                
                            Audio = gameObject.AddComponent<AudioSource>();

                            gameObject.AddComponent<UseEventTrigger>().Action = () =>
                            {
                                if (TextureBool)
                                {                                          
                                    TextureBool = !TextureBool;
                                    body.gameObject.GetComponent<RandomCarTextureBehaviour>().OnAfterChange = new UnityEvent();
                                    gameObject.AddComponent<RandomCarTextureChildBehaviour>().Sprites = OpenSideDoorSprites;
                                    //chair1Renderer.sprite = OpenSideDoorSprite;
                                    //gameObject.transform.localPosition = new Vector3(-2.171f, 0.1428f);                   
                                    Audio.PlayOneShot(DoorSlide);
                                }
                                else
                                {                                           
                                    TextureBool = !TextureBool;
                                    body.gameObject.GetComponent<RandomCarTextureBehaviour>().OnAfterChange = new UnityEvent();
                                    gameObject.AddComponent<RandomCarTextureChildBehaviour>().Sprites = ClosedSideDoorSprites;
                                    //chair1Renderer.sprite = ClosedSideDoorSprite;
                                    //gameObject.transform.localPosition = new Vector3(-0.01439f, 0.1428f);
                                    Audio.PlayOneShot(DoorSlide);
                                }
                            };
                            gameObject.AddComponent<PolygonCollider2D>().pathCount = 1;
                            gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(-1.15714288f,0.971428573f),
                            new Vector2(-1.15714288f,-0.971428573f),
                            new Vector2(1.15714288f,-0.971428573f),
                            new Vector2(1.15714288f,0.971428573f)
                            });
                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rubber");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });
                    //3 Steering Wheel
                        objectSerialisationHelpers[3].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = SteeringWheelSprite;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 1;
                            gameObject.layer = 10;
                            gameObject.AddComponent<Rigidbody2D>().mass = 0.2f;
                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.breakForce = 2000f;
                            AudioSource Audio;                
                            Audio = gameObject.AddComponent<AudioSource>();
                            gameObject.AddComponent<UseEventTrigger>().Action = () =>
                            {
                                Audio.PlayOneShot(Horn);
                            };
                            gameObject.AddComponent<PolygonCollider2D>().pathCount = 1;
                            gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(0.0463324487f,0.22857143f),
                            new Vector2(-0.100000001f,-0.22857143f),
                            new Vector2(-0.0420635641f,-0.226863876f),
                            new Vector2(0.100000001f,0.22857143f),
                            });
                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });                 
                    //Bonnet
                        var bonnet = Instance.transform.GetChild(3);
                        bonnet.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                        bonnet.gameObject.GetComponent<SpriteRenderer>().sortingOrder = -1;
                        //bonnet.gameObject.GetComponent<SpriteRenderer>().sortingOrder = wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        bonnet.gameObject.GetComponent<FixedJoint2D>().breakForce = 500f;
                        bonnet.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.1526f, 0.1444f);
                        var limits = new JointAngleLimits2D();
                        limits.min = -65;
                        limits.max = 0;
                        bonnet.gameObject.GetComponent<HingeJoint2D>().limits = limits;
                        if(firstSpawn)
                        {
                            bonnet.localPosition = new Vector3(3.453f, 0.2398f);
                        }
                        bonnet.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.171428576f,0.18571429f),
                            new Vector2(-0.160942212f,0.1414316f),
                            new Vector2(0.0969347954f,-0.109360337f),
                            new Vector2(0.116916776f,-0.184665635f),
                            new Vector2(0.171428576f,-0.18571429f),
                            new Vector2(0.170380011f,-0.130944937f),
                            new Vector2(-0.153620124f,0.183616981f)
                        });
                    //Engine
                        var engine = Instance.transform.GetChild(7);
                        engine.localScale = new Vector3(0.8f, 0.8f);
                        if(firstSpawn)
                        {
                            engine.localPosition = new Vector3(3.132f, -0.273f);
                        }
                        foreach (Collider2D collider in Instance.transform.GetChild(7).gameObject.GetComponentsInChildren<Collider2D>())
                                {   
                                    NoCollideWithBodyPart noCollide = Instance.transform.GetChild(7).gameObject.AddComponent<NoCollideWithBodyPart>();
                                    noCollide.BodyPart = LimbBehaviour.BodyPart.Legs;
                                    noCollide.Collider = collider;
                                }
                    //Gas Tank
                        var GasTank = Instance.transform.GetChild(8);
                        GasTank.localScale = new Vector3(0.8f, 0.8f);
                        if(firstSpawn)
                        {
                            GasTank.localPosition = new Vector3(-0.771f, -0.699f);
                        }
                        //GameObject.Destroy(GasTank.gameObject.GetComponent<BoxCollider2D>());
                        Instance.transform.GetChild(8).gameObject.AddComponent<BoxCollider2D>();
                        //Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sprite = GasTankSprite;
                        Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
                        foreach (Collider2D collider in Instance.transform.GetChild(7).gameObject.GetComponentsInChildren<Collider2D>())
                                {   
                                    NoCollideWithBodyPart noCollide = Instance.transform.GetChild(8).gameObject.AddComponent<NoCollideWithBodyPart>();
                                    noCollide.BodyPart = LimbBehaviour.BodyPart.Legs;
                                    noCollide.Collider = collider;
                                }
                    //Front Door
                        var frontDoor = Instance.transform.GetChild(5);
                        if(firstSpawn)
                        {
                            frontDoor.localPosition = new Vector3(2.2857f, 0.14285f);
                        }  
                        Instance.transform.GetChild(5).gameObject.GetComponent<PolygonCollider2D>().pathCount = 1;                     
                        Instance.transform.GetChild(5).gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(0.00447686017f,0.971428573f),
                            new Vector2(-0.885714293f,0.971428573f),
                            new Vector2(-0.762458324f,0.0997464806f),
                            new Vector2(-0.494045854f,-0.542443454f),
                            new Vector2(-0.146143794f,-0.47774595f),
                            new Vector2(0.0845730305f,-0.573304892f),
                            new Vector2(0.335408211f,-0.957002819f),
                            new Vector2(0.885714293f,-0.971428573f),
                            new Vector2(0.866067648f,0.30971542f)
                        });
                        frontDoor.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(0.839f, -0.207f);
                        frontDoor.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 6;
                        frontDoor.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground"; 
                    //Wheels
                        WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        if(firstSpawn)
                        {
                            wheels[0].connectedBody.gameObject.transform.localPosition = new Vector2(2.0715f, -0.8717f);
                            wheels[0].connectedBody.gameObject.transform.localScale = new Vector2(1.0f, 1.0f);
                        } 
                        wheels[0].suspension = new JointSuspension2D()
                        {
                            frequency = 14f,
                            angle = 90f,
                            dampingRatio = 0.7f
                        };
                        wheels[0].anchor = new Vector2(2.0715f, -0.8717f);
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel;
                        wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.4428571f;
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder = -2;
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
                        
                        if(firstSpawn)
                        {
                            wheels[1].connectedBody.gameObject.transform.localPosition = new Vector2(-1.9853f, -0.8717f);
                            wheels[1].connectedBody.gameObject.transform.localScale = new Vector2(1.0f, 1.0f);
                        } 
                        wheels[1].suspension = new JointSuspension2D()
                        {
                            frequency = 10f,
                            angle = 90f,
                            dampingRatio = 0.7f
                        };
                        wheels[1].anchor = new Vector2(-1.9853f, -0.8717f);
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel;
                        wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.4428571f;  
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder = -2;
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Background";    
                    //SerialisationSettings
                        if(firstSpawn)
                        {
                            objectSerialisationHelpers[0].InstantiateOverride(objectSerialisationHelpers[0].SerialisationObject);
                            objectSerialisationHelpers[1].InstantiateOverride(objectSerialisationHelpers[1].SerialisationObject);
                            objectSerialisationHelpers[2].InstantiateOverride(objectSerialisationHelpers[2].SerialisationObject);
                            objectSerialisationHelpers[3].InstantiateOverride(objectSerialisationHelpers[3].SerialisationObject);
                        } 
                //                                   
                    }
                }
            );
    //Mitsubishi Fuzion
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Mitsubishi Fuzion",
                    NameToOrderByOverride = "MoreVehicles",
                    DescriptionOverride = "An ordinary family car with a trunk in the back.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Mitsubishi Fuzion.png"), 
                    AfterSpawn = (Instance) =>
                    {
                //Main
                    //Body Sprites
                        Sprite Wheel = ModAPI.LoadSprite("Textures/Mitsubishi Fuzion/Wheel.png");
                        Sprite SteeringWheelSprite = ModAPI.LoadSprite("Textures/Mitsubishi Fuzion/SteeringWheel.png");

                        AudioClip Horn = ModAPI.LoadSound("Sfx/Truck Horn.mp3");
                    //Random Sprites
                        Sprite[] BodyTwoSprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Vintage Pickup/Body2.png"),
                            ModAPI.LoadSprite("Textures/Vintage Pickup/Green/Body2.png"),
                            ModAPI.LoadSprite("Textures/Vintage Pickup/Brown/Body2.png"),
                        };
                        Sprite[] BootSprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Mitsubishi Fuzion/Boot.png"),
                            ModAPI.LoadSprite("Textures/Mitsubishi Fuzion/Boot.png"),
                            ModAPI.LoadSprite("Textures/Mitsubishi Fuzion/Boot.png"),
                        };

                        float MotorSpeed = -3000f; //-2500f
                        bool WaterProof = false;
                        float WeaponSize = 1.0f;

                        bool flipped = Instance.transform.localScale.x < 0f;
						Instance.transform.localScale = new Vector2(WeaponSize * (flipped ? -1f : 1f), WeaponSize);
                       
                        var body = Instance.transform.GetChild(0);
                        bool firstSpawn = (body.localPosition == Vector3.zero);                       
                        var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite1.Body = ModAPI.LoadSprite("Textures/Mitsubishi Fuzion/Body.png");
                        CarSprite1.Background = ModAPI.LoadSprite("Textures/Mitsubishi Fuzion/Background.png");
                        CarSprite1.FrontDoor = ModAPI.LoadSprite("Textures/Mitsubishi Fuzion/Front Door.png");
                        CarSprite1.BackDoor = ModAPI.LoadSprite("Textures/Mitsubishi Fuzion/Back Door.png");
                        CarSprite1.Bonnet = ModAPI.LoadSprite("Textures/Mitsubishi Fuzion/Bonnet.png");
                       
                        Instance.transform.GetChild(4).gameObject.SetActive(false);
                        //Instance.transform.GetChild(6).gameObject.SetActive(false); //Back Door
                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingOrder = 5;
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().chosenIndex = UnityEngine.Random.Range(0, 1);
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[] 
                        {
                            CarSprite1,
                        };                      
                //Settings                 
                    //GameObjects
                        Transform BodyFrame = Instance.transform.GetChild(0);
                        Transform frameBackground = BodyFrame.GetChild(0);
                        frameBackground.localPosition = new Vector3(0f, 0f);                  

                        if(firstSpawn)
                        {                                          
                            BodyFrame.localPosition = Vector3.zero;
                            BodyFrame.gameObject.name = "Body";
                            //frame.gameObject.AddComponent<Optout>();
                            Instance.AddComponent<ObjectSerialisationHelper>(); 

                            GameObject BootPart = new GameObject("Boot");
                            BootPart.transform.parent = Instance.transform;
                            BootPart.transform.rotation = BodyFrame.rotation;
                            BootPart.transform.localScale = Vector3.one;
                            BootPart.transform.localPosition = new Vector3(-3.015f, 0.199f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = BootPart;

                            GameObject SteeringWheelPart = new GameObject("Steering Wheel");
                            SteeringWheelPart.transform.parent = Instance.transform;
                            SteeringWheelPart.transform.rotation = BodyFrame.rotation;
                            SteeringWheelPart.transform.localScale = Vector3.one; 
                            SteeringWheelPart.transform.localPosition = new Vector3(1.286f, 0.229f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = SteeringWheelPart;                    
                        }                                             
                    //0 Body
                        ObjectSerialisationHelper[] objectSerialisationHelpers = Instance.GetComponents<ObjectSerialisationHelper>();
                        objectSerialisationHelpers[0].SerialisationObject = BodyFrame.gameObject;
                        objectSerialisationHelpers[0].InstantiateOverride = ((gameObject) =>
                        {
                            //CarBehaviour beh = BodyFrame.gameObject.GetComponent<CarBehaviour>();
                            //beh.EngineStartup = ModAPI.LoadSound("Sfx/Startup.mp3");
                            //beh.EngineShutoff = ModAPI.LoadSound("Sfx/Shutoff.mp3");
                            //beh.EngineLoop = ModPI.LoadSound("Sfx/Loop.mp3");
                            gameObject.GetComponent<CarBehaviour>().MotorSpeed = MotorSpeed;
                            gameObject.GetComponent<CarBehaviour>().WaterProof = WaterProof;
                            gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            gameObject.GetComponent<SpriteRenderer>().sortingOrder = 3;
                            PhysicalBehaviour phys = gameObject.GetComponent<PhysicalBehaviour>();
                            phys.TrueInitialMass = 18f;
                            phys.InitialMass = 18f;
                            phys.rigidbody.mass = 18f;
                            BoxCollider2D[] boxColliders = gameObject.GetComponents<BoxCollider2D>();
                            GameObject.Destroy(boxColliders[0]);
                            GameObject.Destroy(boxColliders[1]);
                            GameObject.Destroy(boxColliders[2]);
                            GameObject.Destroy(boxColliders[3]);
                            PolygonCollider2D collider1 = gameObject.GetComponent<PolygonCollider2D>();
                            collider1.pathCount = 3;
                            collider1.SetPath(0, new Vector2[]
                            {
                            new Vector2(1.8311367f,0.415661991f),
                            new Vector2(0.968008041f,1.1301384f),
                            new Vector2(0.795776367f,1.24012637f),
                            new Vector2(0.511253834f,1.28947353f),
                            new Vector2(-2.49411678f,1.29037333f),
                            new Vector2(-2.84219599f,1.18727517f),
                            new Vector2(-3.00706768f,1.04164135f),
                            new Vector2(-2.57092571f,1.17816389f),
                            new Vector2(0.715112209f,1.15423727f),
                            new Vector2(1.58381796f,0.345743299f),
                            new Vector2(1.58915329f,-0.654538095f),
                            new Vector2(-1.05548954f,-0.656983256f),
                            new Vector2(-1.18567896f,-0.657103658f),
                            new Vector2(-1.36712551f,-0.386009574f),
                            new Vector2(-1.69235516f,-0.307964325f),
                            new Vector2(-1.99795437f,-0.419532329f),
                            new Vector2(-2.19279766f,-0.658034801f),
                            new Vector2(-2.95733929f,-0.658741713f),
                            new Vector2(-2.76852036f,-0.938400805f),
                            new Vector2(2.86924076f,-0.920236111f),
                            new Vector2(3.13775158f,-0.703185081f),
                            new Vector2(3.06544566f,0.0845822692f),
                            new Vector2(2.12985063f,0.0622216463f)
                            });
                            collider1.SetPath(1, new Vector2[]
                            {
                            new Vector2(0.555399418f,-0.281830072f),
                            new Vector2(1.00259542f,-0.250593603f),
                            new Vector2(1.04066038f,-0.369113028f),
                            new Vector2(0.868457794f,-0.644539237f),
                            new Vector2(0.505991936f,-0.643406034f),
                            new Vector2(0.342801571f,-0.464379847f),
                            new Vector2(0.304600716f,0.957809448f),
                            new Vector2(0.458066225f,0.973966599f)
                            });
                            collider1.SetPath(2, new Vector2[]
                            {
                            new Vector2(-0.784033775f,-0.270721316f),
                            new Vector2(-0.363283157f,-0.255542904f),
                            new Vector2(-0.297355175f,-0.387181163f),
                            new Vector2(-0.463256359f,-0.641720235f),
                            new Vector2(-0.835574627f,-0.6439448f),
                            new Vector2(-0.986845493f,-0.461124897f),
                            new Vector2(-1.04435968f,0.993759036f),
                            new Vector2(-0.873331547f,0.963154554f)
                            });
                        });
                    //1 Boot
                        objectSerialisationHelpers[1].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            body.gameObject.GetComponent<RandomCarTextureBehaviour>().OnAfterChange = new UnityEvent();
                            gameObject.AddComponent<RandomCarTextureChildBehaviour>().Sprites = BootSprites;
                            //chair1Renderer.sprite = BootSprite;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 1;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            gameObject.AddComponent<Rigidbody2D>().mass = 0.2f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.breakForce = 300f;

                            HingeJoint2D hingeJoint = gameObject.AddComponent<HingeJoint2D>();
                            hingeJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            hingeJoint.anchor = new Vector2(0.041f, 0.807f);
                            hingeJoint.breakForce = 5000f;
                            hingeJoint.breakTorque = 5000f;
                            hingeJoint.useMotor = true;
                            AudioSource Audio;                
                            Audio = gameObject.AddComponent<AudioSource>();

                            gameObject.GetComponent<HingeJoint2D>().limits = new JointAngleLimits2D()
                            {
                                min = 0,
                                max = 120
                            };
                            float BootSpeed = -0f; 
                            float BootTorque = 8f; 
                            bool OpenCloseBoot = true;
                            hingeJoint.motor = new JointMotor2D
                            {
                                maxMotorTorque = BootTorque,
                                motorSpeed = BootSpeed
                            };                                                
                            gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(0.00437899679f,0.858460844f),
                            new Vector2(-0.112232782f,0.393628418f),
                            new Vector2(-0.112160683f,-0.173596323f),
                            new Vector2(-0.0583295822f,-0.359005928f),
                            new Vector2(-0.118124008f,-0.404360294f),
                            new Vector2(-0.116869926f,-0.455391884f),
                            new Vector2(-0.0596796051f,-0.461553484f),
                            new Vector2(0.0298156999f,-0.858190596f),
                            new Vector2(0.114204027f,-0.854316652f),
                            new Vector2(-0.0286197662f,-0.165166542f),
                            new Vector2(-0.0252494812f,0.387189329f),
                            new Vector2(0.0883775726f,0.858190596f)
                            });
                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });
                    //2 Steering Wheel
                        objectSerialisationHelpers[2].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = SteeringWheelSprite;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 1;
                            gameObject.layer = 10;
                            gameObject.AddComponent<Rigidbody2D>().mass = 0.2f;
                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.breakForce = 152000f;
                            AudioSource Audio;                
                            Audio = gameObject.AddComponent<AudioSource>();
                            gameObject.AddComponent<UseEventTrigger>().Action = () =>
                            {
                                Audio.PlayOneShot(Horn);
                            };
                            gameObject.AddComponent<PolygonCollider2D>().pathCount = 1;
                            gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(0.0463324487f,0.22857143f),
                            new Vector2(-0.100000001f,-0.22857143f),
                            new Vector2(-0.0420635641f,-0.226863876f),
                            new Vector2(0.100000001f,0.22857143f),
                            });
                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });                 
                    //Bonnet
                        var bonnet = Instance.transform.GetChild(3);
                        bonnet.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        bonnet.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 7;
                        //bonnet.gameObject.GetComponent<SpriteRenderer>().sortingOrder = wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        bonnet.gameObject.GetComponent<FixedJoint2D>().breakForce = 500f;
                        bonnet.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.57f, 0.126f);
                        var limits = new JointAngleLimits2D();
                        limits.min = -65;
                        limits.max = 0;
                        bonnet.gameObject.GetComponent<HingeJoint2D>().limits = limits;
                        if(firstSpawn)
                        {
                            bonnet.localPosition = new Vector3(2.441f, 0.243f);
                        }
                        bonnet.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(0.60437727f,-0.121885993f),
                            new Vector2(0.337554693f,0.0142583549f),
                            new Vector2(-0.600000024f,0.157142863f),
                            new Vector2(-0.600000024f,0.096889019f),
                            new Vector2(0.228675604f,-0.0248475224f),
                            new Vector2(0.587595582f,-0.163000911f)
                        });
                    //Engine
                        var engine = Instance.transform.GetChild(7);
                        engine.localScale = new Vector3(0.9f, 0.9f);
                        if(firstSpawn)
                        {
                            engine.localPosition = new Vector3(2.268f, -0.263f);
                        }
                    //Gas Tank
                        var GasTank = Instance.transform.GetChild(8);
                        GasTank.localScale = new Vector3(0.9f, 0.9f);
                        if(firstSpawn)
                        {
                            GasTank.localPosition = new Vector3(-0.795f, -0.633f);
                        }
                        //GameObject.Destroy(GasTank.gameObject.GetComponent<BoxCollider2D>());
                        Instance.transform.GetChild(8).gameObject.AddComponent<BoxCollider2D>();
                        //Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sprite = GasTankSprite;
                        Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
                    //Front Door
                        var frontDoor = Instance.transform.GetChild(5);
                        if(firstSpawn)
                        {
                            frontDoor.localPosition = new Vector3(0.78569f, 0.15715f);
                        }                       
                        Instance.transform.GetChild(5).gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.356814861f,1.04376006f),
                            new Vector2(-0.828571439f,1.04285717f),
                            new Vector2(-0.668408036f,0.0750686601f),
                            new Vector2(-0.600356102f,-0.291737825f),
                            new Vector2(-0.608723521f,-1.03557706f),
                            new Vector2(0.741209626f,-1.04649723f),
                            new Vector2(0.8264184f,-0.804066181f),
                            new Vector2(0.825346112f,0.192139477f),
                            new Vector2(0.141904846f,0.893809617f)
                        });
                        frontDoor.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(0.8f, 0f);
                        frontDoor.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 7;
                        frontDoor.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground"; 
                    //Back Door
                        var backDoor = Instance.transform.GetChild(6);
                        if(firstSpawn)
                        {
                            backDoor.localPosition = new Vector3(-0.7149f, 0.157f);
                        }                       
                        Instance.transform.GetChild(6).gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.668017149f,1.03913713f),
                            new Vector2(-0.842734814f,0.583417773f),
                            new Vector2(-0.924851179f,0.0686337948f),
                            new Vector2(-0.924851179f,-0.389588505f),
                            new Vector2(-0.674237728f,-0.471336842f),
                            new Vector2(-0.46423769f,-0.661635756f),
                            new Vector2(-0.343606055f,-1.04285717f),
                            new Vector2(0.928571463f,-1.04285717f),
                            new Vector2(0.929633141f,-0.271559596f),
                            new Vector2(0.839291334f,0.0827427953f),
                            new Vector2(0.69896549f,1.04285717f)
                        });
                        backDoor.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(0.8583f, 0f);
                        backDoor.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 6;
                        backDoor.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground"; 
                    //Wheels
                        WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        if(firstSpawn)
                        {
                            wheels[0].connectedBody.gameObject.transform.localPosition = new Vector2(-1.6859f, -0.8436f);
                            wheels[0].connectedBody.gameObject.transform.localScale = new Vector2(1f, 1f);
                        } 
                        wheels[0].anchor = new Vector2(-1.6859f, -0.8436f);
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel;
                        wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.4428571f;
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder = -2;
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
                        
                        if(firstSpawn)
                        {
                            wheels[1].connectedBody.gameObject.transform.localPosition = new Vector2(2.2286f, -0.8436f);
                            wheels[1].connectedBody.gameObject.transform.localScale = new Vector2(1f, 1f);
                        } 
                        wheels[1].anchor = new Vector2(2.2286f, -0.8436f);
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel;
                        wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.4428571f;  
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder = -2;
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Background";    
                    //SerialisationSettings
                        if(firstSpawn)
                        {
                            objectSerialisationHelpers[0].InstantiateOverride(objectSerialisationHelpers[0].SerialisationObject);
                            objectSerialisationHelpers[1].InstantiateOverride(objectSerialisationHelpers[1].SerialisationObject);
                            objectSerialisationHelpers[2].InstantiateOverride(objectSerialisationHelpers[2].SerialisationObject);
                        } 
                //                                   
                    }
                }
            );
    //Toyota Revo 2000
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Toyota Revo 2000",
                    NameToOrderByOverride = "MoreVehicles",
                    DescriptionOverride = "A family car, but only faster. And heavier.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Toyota Revo 2000.png"), 
                    AfterSpawn = (Instance) =>
                    {
                //Main
                    //Body Sprites
                        Sprite Wheel = ModAPI.LoadSprite("Textures/Toyota Revo 2000/Wheel.png");
                        Sprite SteeringWheelSprite = ModAPI.LoadSprite("Textures/Toyota Revo 2000/SteeringWheel.png");

                        AudioClip Horn = ModAPI.LoadSound("Sfx/Truck Horn.mp3");
                    //Random Sprites
                        Sprite[] BootSprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Toyota Revo 2000/Boot.png"),
                            ModAPI.LoadSprite("Textures/Toyota Revo 2000/Boot.png"),
                            ModAPI.LoadSprite("Textures/Toyota Revo 2000/Boot.png"),
                        };

                        float MotorSpeed = -3500f; //-2500f
                        bool WaterProof = false;
                        float WeaponSize = 1.0f;

                        bool flipped = Instance.transform.localScale.x < 0f;
						Instance.transform.localScale = new Vector2(WeaponSize * (flipped ? -1f : 1f), WeaponSize);
                       
                        var body = Instance.transform.GetChild(0);
                        bool firstSpawn = (body.localPosition == Vector3.zero);                       
                        var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite1.Body = ModAPI.LoadSprite("Textures/Toyota Revo 2000/Body.png");
                        CarSprite1.Background = ModAPI.LoadSprite("Textures/Toyota Revo 2000/Background.png");
                        CarSprite1.FrontDoor = ModAPI.LoadSprite("Textures/Toyota Revo 2000/Front Door.png");
                        CarSprite1.BackDoor = ModAPI.LoadSprite("Textures/Toyota Revo 2000/Back Door.png");
                        CarSprite1.Bonnet = ModAPI.LoadSprite("Textures/Toyota Revo 2000/Bonnet.png");
                       
                        Instance.transform.GetChild(4).gameObject.SetActive(false);
                        //Instance.transform.GetChild(6).gameObject.SetActive(false); //Back Door
                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingOrder = 5;
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().chosenIndex = UnityEngine.Random.Range(0, 1);
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[] 
                        {
                            CarSprite1,
                        };                      
                //Settings                 
                    //GameObjects
                        Transform BodyFrame = Instance.transform.GetChild(0);
                        Transform frameBackground = BodyFrame.GetChild(0);
                        frameBackground.localPosition = new Vector3(0f, 0f);                  

                        if(firstSpawn)
                        {                                          
                            BodyFrame.localPosition = Vector3.zero;
                            BodyFrame.gameObject.name = "Body";
                            //frame.gameObject.AddComponent<Optout>();
                            Instance.AddComponent<ObjectSerialisationHelper>(); 

                            GameObject BootPart = new GameObject("Boot");
                            BootPart.transform.parent = Instance.transform;
                            BootPart.transform.rotation = BodyFrame.rotation;
                            BootPart.transform.localScale = Vector3.one;
                            BootPart.transform.localPosition = new Vector3(-2.869f, 0.152f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = BootPart;

                            GameObject SteeringWheelPart = new GameObject("Steering Wheel");
                            SteeringWheelPart.transform.parent = Instance.transform;
                            SteeringWheelPart.transform.rotation = BodyFrame.rotation;
                            SteeringWheelPart.transform.localScale = Vector3.one; 
                            SteeringWheelPart.transform.localPosition = new Vector3(1.0719f, 0.2718f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = SteeringWheelPart;                    
                        }                                             
                    //0 Body
                        ObjectSerialisationHelper[] objectSerialisationHelpers = Instance.GetComponents<ObjectSerialisationHelper>();
                        objectSerialisationHelpers[0].SerialisationObject = BodyFrame.gameObject;
                        objectSerialisationHelpers[0].InstantiateOverride = ((gameObject) =>
                        {
                            //CarBehaviour beh = BodyFrame.gameObject.GetComponent<CarBehaviour>();
                            //beh.EngineStartup = ModAPI.LoadSound("Sfx/Startup.mp3");
                            //beh.EngineShutoff = ModAPI.LoadSound("Sfx/Shutoff.mp3");
                            //beh.EngineLoop = ModPI.LoadSound("Sfx/Loop.mp3");
                            gameObject.GetComponent<CarBehaviour>().MotorSpeed = MotorSpeed;
                            gameObject.GetComponent<CarBehaviour>().WaterProof = WaterProof;
                            gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            gameObject.GetComponent<SpriteRenderer>().sortingOrder = 3;
                            PhysicalBehaviour phys = gameObject.GetComponent<PhysicalBehaviour>();
                            phys.TrueInitialMass = 22f;
                            phys.InitialMass = 22f;
                            phys.rigidbody.mass = 22f;
                            BoxCollider2D[] boxColliders = gameObject.GetComponents<BoxCollider2D>();
                            GameObject.Destroy(boxColliders[0]);
                            GameObject.Destroy(boxColliders[1]);
                            GameObject.Destroy(boxColliders[2]);
                            GameObject.Destroy(boxColliders[3]);
                            PolygonCollider2D collider1 = gameObject.GetComponent<PolygonCollider2D>();
                            collider1.pathCount = 3;
                            collider1.SetPath(0, new Vector2[]
                            {
                            new Vector2(2.82170081f,-1.07129943f),
                            new Vector2(2.99307418f,-0.977823913f),
                            new Vector2(3.0338974f,-0.503300369f),
                            new Vector2(2.9792819f,-0.49780944f),
                            new Vector2(2.91361332f,-0.0426378176f),
                            new Vector2(1.94697714f,0.0888080001f),
                            new Vector2(1.88824177f,0.307202131f),
                            new Vector2(1.59909379f,0.375730336f),
                            new Vector2(1.59909379f,0.375730336f),
                            new Vector2(0.648338735f,1.15740693f),
                            new Vector2(-2.43492842f,1.16357052f),
                            new Vector2(-3.03610945f,1.06566489f),
                            new Vector2(-2.88893104f,0.988269448f),
                            new Vector2(-2.7911129f,0.822994709f),
                            new Vector2(-2.38681579f,1.05177855f),
                            new Vector2(0.721058667f,1.06867301f),
                            new Vector2(1.51006806f,0.322280705f),
                            new Vector2(1.68957508f,-0.368269026f),
                            new Vector2(1.19214964f,-0.781287909f),
                            new Vector2(-1.08993983f,-0.777921438f),
                            new Vector2(-1.23253095f,-0.541026056f),
                            new Vector2(-1.59278977f,-0.439583302f),
                            new Vector2(-1.90182102f,-0.511364162f),
                            new Vector2(-2.07388735f,-0.780359983f),
                            new Vector2(-2.76807213f,-0.782760501f),
                            new Vector2(-2.753649f,-0.498915195f),
                            new Vector2(-2.89995861f,-0.496296287f),
                            new Vector2(-2.9929285f,-0.540768802f),
                            new Vector2(-3.00796342f,-0.783590019f),
                            new Vector2(-2.9944315f,-0.915023088f),
                            new Vector2(-2.83554077f,-1.06771421f),
                            });
                            collider1.SetPath(1, new Vector2[]
                            {
                            new Vector2(0.203713924f,0.815220952f),
                            new Vector2(0.237790942f,-0.556316495f),
                            new Vector2(0.404628724f,-0.770644248f),
                            new Vector2(0.765821576f,-0.76600045f),
                            new Vector2(0.942205429f,-0.54088521f),
                            new Vector2(0.892956078f,-0.394966811f),
                            new Vector2(0.452523977f,-0.405065626f),
                            new Vector2(0.383435011f,0.830627441f)
                            });
                            collider1.SetPath(2, new Vector2[]
                            {
                            new Vector2(-1.17651582f,0.822243929f),
                            new Vector2(-1.00487411f,0.837704182f),
                            new Vector2(-0.91116184f,-0.401181817f),
                            new Vector2(-0.489073157f,-0.373962134f),
                            new Vector2(-0.424105376f,-0.478737235f),
                            new Vector2(-0.610542059f,-0.761080623f),
                            new Vector2(-0.992741406f,-0.76062578f),
                            new Vector2(-1.08560658f,-0.468387604f)
                            });
                        });
                    //1 Boot
                        objectSerialisationHelpers[1].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            body.gameObject.GetComponent<RandomCarTextureBehaviour>().OnAfterChange = new UnityEvent();
                            gameObject.AddComponent<RandomCarTextureChildBehaviour>().Sprites = BootSprites;
                            //chair1Renderer.sprite = BootSprite;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 1;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            gameObject.AddComponent<Rigidbody2D>().mass = 0.2f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.breakForce = 300f;

                            HingeJoint2D hingeJoint = gameObject.AddComponent<HingeJoint2D>();
                            hingeJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            hingeJoint.anchor = new Vector2(0.115f, 0.608f);
                            hingeJoint.breakForce = 5000f;
                            hingeJoint.breakTorque = 5000f;
                            hingeJoint.useMotor = true;
                            AudioSource Audio;                
                            Audio = gameObject.AddComponent<AudioSource>();

                            gameObject.GetComponent<HingeJoint2D>().limits = new JointAngleLimits2D()
                            {
                                min = 0,
                                max = 120
                            };
                            float BootSpeed = -0f; 
                            float BootTorque = 8f; 
                            bool OpenCloseBoot = true;
                            hingeJoint.motor = new JointMotor2D
                            {
                                maxMotorTorque = BootTorque,
                                motorSpeed = BootSpeed
                            };                                                
                            gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(0.0726545155f,0.654921472f),
                            new Vector2(-0.0372638553f,0.142932758f),
                            new Vector2(-0.0452077389f,-0.362253457f),
                            new Vector2(-0.0984768867f,-0.397991061f),
                            new Vector2(-0.102345467f,-0.463537633f),
                            new Vector2(-0.0394191742f,-0.459718943f),
                            new Vector2(-0.0126733631f,-0.659939647f),
                            new Vector2(0.074779436f,-0.657142878f),
                            new Vector2(0.0436501503f,-0.482729137f),
                            new Vector2(0.0535264015f,0.125624165f),
                            new Vector2(0.157142863f,0.657142878f)
                            });
                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });
                    //2 Steering Wheel
                        objectSerialisationHelpers[2].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = SteeringWheelSprite;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 1;
                            gameObject.layer = 10;
                            gameObject.AddComponent<Rigidbody2D>().mass = 0.2f;
                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.breakForce = 152000f;
                            AudioSource Audio;                
                            Audio = gameObject.AddComponent<AudioSource>();
                            gameObject.AddComponent<UseEventTrigger>().Action = () =>
                            {
                                Audio.PlayOneShot(Horn);
                            };
                            gameObject.AddComponent<PolygonCollider2D>().pathCount = 1;
                            gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(0.0463324487f,0.22857143f),
                            new Vector2(-0.100000001f,-0.22857143f),
                            new Vector2(-0.0420635641f,-0.226863876f),
                            new Vector2(0.100000001f,0.22857143f),
                            });
                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });                 
                    //Bonnet
                        var bonnet = Instance.transform.GetChild(3);
                        bonnet.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        bonnet.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 7;
                        //bonnet.gameObject.GetComponent<SpriteRenderer>().sortingOrder = wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        bonnet.gameObject.GetComponent<FixedJoint2D>().breakForce = 500f;
                        bonnet.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.47f, 0.152f);
                        var limits = new JointAngleLimits2D();
                        limits.min = -65;
                        limits.max = 0;
                        bonnet.gameObject.GetComponent<HingeJoint2D>().limits = limits;
                        if(firstSpawn)
                        {
                            bonnet.localPosition = new Vector3(2.3837f, 0.1107f);
                        }
                        bonnet.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(0.0695784092f,0.0762012303f),
                            new Vector2(-0.5f,0.18571429f),
                            new Vector2(-0.496985435f,0.131719917f),
                            new Vector2(0.0538766533f,0.00996474177f),
                            new Vector2(0.5f,-0.18571429f),
                            new Vector2(0.495478153f,-0.128973201f)
                        });
                    //Engine
                        var engine = Instance.transform.GetChild(7);
                        engine.localScale = new Vector3(0.9f, 0.9f);
                        if(firstSpawn)
                        {
                            engine.localPosition = new Vector3(2.268f, -0.263f);
                        }
                    //Gas Tank
                        var GasTank = Instance.transform.GetChild(8);
                        GasTank.localScale = new Vector3(0.9f, 0.9f);
                        if(firstSpawn)
                        {
                            GasTank.localPosition = new Vector3(-0.795f, -0.633f);
                        }
                        //GameObject.Destroy(GasTank.gameObject.GetComponent<BoxCollider2D>());
                        Instance.transform.GetChild(8).gameObject.AddComponent<BoxCollider2D>();
                        //Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sprite = GasTankSprite;
                        Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
                    //Front Door
                        var frontDoor = Instance.transform.GetChild(5);
                        if(firstSpawn)
                        {
                            frontDoor.localPosition = new Vector3(0.8286f, 0.04277f);
                        }                       
                        Instance.transform.GetChild(5).gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-1.02857149f,1.05714285f),
                            new Vector2(-0.841279268f,-0.0694906339f),
                            new Vector2(-0.82893151f,-1.05714285f),
                            new Vector2(0.39918825f,-1.05714285f),
                            new Vector2(0.475878298f,-0.735037684f),
                            new Vector2(0.688392699f,-0.448924214f),
                            new Vector2(1.03668344f,-0.386840373f),
                            new Vector2(0.95826906f,0.191888198f),
                            new Vector2(0.655377567f,0.330031157f),
                            new Vector2(-0.0209161043f,0.992904544f),
                            new Vector2(-0.209909618f,1.05714285f)
                        });
                        frontDoor.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(0.98f, 0f);
                        frontDoor.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 7;
                        frontDoor.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground"; 
                    //Back Door
                        var backDoor = Instance.transform.GetChild(6);
                        if(firstSpawn)
                        {
                            backDoor.localPosition = new Vector3(-0.7716f, 0.0429f);
                        }                       
                        Instance.transform.GetChild(6).gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.569396734f,1.05456209f),
                            new Vector2(-0.798392713f,-0.0613634586f),
                            new Vector2(-0.805161536f,-0.371977419f),
                            new Vector2(-0.573842764f,-0.40810594f),
                            new Vector2(-0.256559134f,-0.59445405f),
                            new Vector2(-0.139296308f,-1.05714285f),
                            new Vector2(0.800000012f,-1.05714285f),
                            new Vector2(0.792539775f,-0.0799939334f),
                            new Vector2(0.571350217f,1.04968262f)
                        });
                        backDoor.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(0.745f, 0f);
                        backDoor.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 6;
                        backDoor.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground"; 
                    //Wheels
                        WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        if(firstSpawn)
                        {
                            wheels[0].connectedBody.gameObject.transform.localPosition = new Vector2(-1.5855f, -0.9725f);
                            wheels[0].connectedBody.gameObject.transform.localScale = new Vector2(1f, 1f);
                        } 
                        wheels[0].anchor = new Vector2(-1.5855f, -0.9725f);
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel;
                        wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.4428571f;
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder = -2;
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
                        
                        if(firstSpawn)
                        {
                            wheels[1].connectedBody.gameObject.transform.localPosition = new Vector2(1.9003f, -0.9725f);
                            wheels[1].connectedBody.gameObject.transform.localScale = new Vector2(1f, 1f);
                        } 
                        wheels[1].anchor = new Vector2(1.9003f, -0.9725f);
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel;
                        wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.4428571f;  
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder = -2;
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Background";    
                    //SerialisationSettings
                        if(firstSpawn)
                        {
                            objectSerialisationHelpers[0].InstantiateOverride(objectSerialisationHelpers[0].SerialisationObject);
                            objectSerialisationHelpers[1].InstantiateOverride(objectSerialisationHelpers[1].SerialisationObject);
                            objectSerialisationHelpers[2].InstantiateOverride(objectSerialisationHelpers[2].SerialisationObject);
                        } 
                //                                   
                    }
                }
            );
    //Motorcycle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Motorcycle",
                    NameToOrderByOverride = "MoreVehicles",
                    DescriptionOverride = "Fast motorcycle! Unfortunately, you can't put it in the water!",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Motorcycle.png"), 
                    AfterSpawn = (Instance) =>
                    {
                //Main
                    //Body Sprites
                        Sprite Mirror = ModAPI.LoadSprite("Textures/NSR Truck/Mirror.png");
                        Sprite CabinBackground = ModAPI.LoadSprite("Textures/NSR Truck/CabinBackground.png");
                        Sprite Wheel = ModAPI.LoadSprite("Textures/Motorcycle/Wheel.png");
                        Sprite GasTankSprite = ModAPI.LoadSprite("Textures/Motorcycle/Gas Tank.png");
                        Sprite EngineSprite = ModAPI.LoadSprite("Textures/Motorcycle/Engine.png");
                    //Fenders
                        Sprite FrontFender = ModAPI.LoadSprite("Textures/Motorcycle/FrontFender.png");
                        Sprite FrontFender2 = ModAPI.LoadSprite("Textures/Motorcycle/FrontFender2.png");
                        Sprite BackFender = ModAPI.LoadSprite("Textures/Motorcycle/BackFender.png");
                        Sprite BackFender2 = ModAPI.LoadSprite("Textures/Motorcycle/BackFender2.png");
                    //Random Sprites
                        Sprite[] LightSprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Motorcycle/Light.png"),
                            ModAPI.LoadSprite("Textures/Motorcycle/Texture2/Light.png"),
                            ModAPI.LoadSprite("Textures/Motorcycle/Texture3/Light.png"),
                            ModAPI.LoadSprite("Textures/Motorcycle/Texture4/Light.png"),
                        };

                        //Sprite Light = ModAPI.LoadSprite("Textures/Motorcycle/Light.png");
                        //Sprite Light2 = ModAPI.LoadSprite("Textures/Motorcycle/Texture2/Light.png");
                        //Sprite Light3 = ModAPI.LoadSprite("Textures/Motorcycle/Texture3/Light.png");
                        //Sprite Light4 = ModAPI.LoadSprite("Textures/Motorcycle/Texture4/Light.png");

                        float MotorSpeed = -2300f;
                        bool WaterProof = false;
                       
                        var body = Instance.transform.GetChild(0);
                        bool firstSpawn = (body.localPosition == Vector3.zero);                       
                        var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite1.Body = ModAPI.LoadSprite("Textures/Motorcycle/Body.png");
                        CarSprite1.Background = ModAPI.LoadSprite("Textures/Motorcycle/None.png");

                        var CarSprite2 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite2.Body = ModAPI.LoadSprite("Textures/Motorcycle/Texture2/Body.png");
                        CarSprite2.Background = ModAPI.LoadSprite("Textures/Motorcycle/None.png");
                        
                        var CarSprite3 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite3.Body = ModAPI.LoadSprite("Textures/Motorcycle/Texture3/Body.png");
                        CarSprite3.Background = ModAPI.LoadSprite("Textures/Motorcycle/None.png");

                        var CarSprite4 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite4.Body = ModAPI.LoadSprite("Textures/Motorcycle/Texture4/Body.png");
                        CarSprite4.Background = ModAPI.LoadSprite("Textures/Motorcycle/None.png");

                        Instance.transform.GetChild(5).gameObject.SetActive(false);
                        Instance.transform.GetChild(3).gameObject.SetActive(false);
                        Instance.transform.GetChild(4).gameObject.SetActive(false);
                        Instance.transform.GetChild(6).gameObject.SetActive(false); //Back Door
                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingOrder = 5;
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().chosenIndex = UnityEngine.Random.Range(0, 4);
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[] 
                        {
                            CarSprite1,
                            CarSprite2,
                            CarSprite3,
                            CarSprite4
                        };                      
                //Settings
                    //GameObjects
                        Transform BodyFrame = Instance.transform.GetChild(0);
                        //BodyFrame.GetComponent<RandomCarTextureBehaviour>().chosenIndex = UnityEngine.Random.Range(0, 4);
                        GameObject LightObj = new GameObject("Light"); 
                        if(firstSpawn)
                        {                                          
                            GameObject FrontFenderObj = new GameObject("Front Fender");
                            FrontFenderObj.transform.parent = Instance.transform;
                            FrontFenderObj.transform.rotation = BodyFrame.rotation;
                            FrontFenderObj.transform.localScale = Vector3.one;
                            FrontFenderObj.transform.localPosition = new Vector3(0.827f, -0.356f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = FrontFenderObj;

                            GameObject FrontFenderObj2 = new GameObject("Front Fender 2");
                            FrontFenderObj2.transform.parent = Instance.transform;
                            FrontFenderObj2.transform.rotation = BodyFrame.rotation;
                            FrontFenderObj2.transform.localScale = Vector3.one;
                            FrontFenderObj2.transform.localPosition = new Vector3(1.314f, -0.099f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = FrontFenderObj2;

                            GameObject BackFenderObj = new GameObject("Back Fender");
                            BackFenderObj.transform.parent = Instance.transform;
                            BackFenderObj.transform.rotation = BodyFrame.rotation;
                            BackFenderObj.transform.localScale = Vector3.one;
                            BackFenderObj.transform.localPosition = new Vector3(-1.258746f, -0.2714922f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = BackFenderObj;

                            GameObject BackFenderObj2 = new GameObject("Back Fender 2");
                            BackFenderObj2.transform.parent = Instance.transform;
                            BackFenderObj2.transform.rotation = BodyFrame.rotation;
                            BackFenderObj2.transform.localScale = Vector3.one;
                            BackFenderObj2.transform.localPosition = new Vector3(-0.785f, -0.126f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = BackFenderObj2;

                            BodyFrame.localPosition = Vector3.zero;
                            BodyFrame.gameObject.name = "Body";
                            //frame.gameObject.AddComponent<Optout>();
                            Instance.AddComponent<ObjectSerialisationHelper>(); 

                            //GameObject LightObj = new GameObject("Light");
                            LightObj.transform.parent = Instance.transform;
                            LightObj.transform.rotation = BodyFrame.rotation;
                            LightObj.transform.localScale = Vector3.one;
                            LightObj.transform.localPosition = new Vector3(0.954f, 0.418f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = LightObj;                     
                        }                                             
                    //Engine&Gas Tank
                        var engine = Instance.transform.GetChild(7);
                        engine.localScale = new Vector3(1f, 1f);
                        if(firstSpawn)
                        {
                            engine.localPosition = new Vector3(-0.007f, 0.003f);
                        }
                        GameObject.Destroy(engine.gameObject.GetComponent<BoxCollider2D>());
                        Instance.transform.GetChild(7).gameObject.AddComponent<CircleCollider2D>();
                        Instance.transform.GetChild(7).gameObject.GetComponent<CircleCollider2D>().radius = 0.2f;
                        Instance.transform.GetChild(7).gameObject.GetComponent<SpriteRenderer>().sprite = EngineSprite;
                        Instance.transform.GetChild(7).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                        foreach (Collider2D collider in Instance.transform.GetChild(7).gameObject.GetComponentsInChildren<Collider2D>())
                                {   
                                    NoCollideWithBodyPart noCollide = Instance.transform.GetChild(7).gameObject.AddComponent<NoCollideWithBodyPart>();
                                    noCollide.BodyPart = LimbBehaviour.BodyPart.Legs;
                                    noCollide.Collider = collider;
                                }

                        var GasTank = Instance.transform.GetChild(8);
                        GasTank.localScale = new Vector3(1f, 1f);
                        if(firstSpawn)
                        {
                            GasTank.localPosition = new Vector3(0.431f, 0.034f);
                        }
                        GameObject.Destroy(GasTank.gameObject.GetComponent<BoxCollider2D>());
                        Instance.transform.GetChild(8).gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                                new Vector2(-0.300000012f,0.157142863f),
                                new Vector2(-0.300000012f,-0.157142863f),
                                new Vector2(0.130043849f,-0.157142863f),
                                new Vector2(0.298886597f,0.0116999f),
                                new Vector2(0.271032572f,0.127796769f),
                                new Vector2(0.0706378222f,0.157142863f)
                            });
                        Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sprite = GasTankSprite;
                        Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                        foreach (Collider2D collider in Instance.transform.GetChild(8).gameObject.GetComponentsInChildren<Collider2D>())
                                {   
                                    NoCollideWithBodyPart noCollide = Instance.transform.GetChild(8).gameObject.AddComponent<NoCollideWithBodyPart>();
                                    noCollide.BodyPart = LimbBehaviour.BodyPart.Legs;
                                    noCollide.Collider = collider;
                                }
                        
                    //0 Front Fender
                        ObjectSerialisationHelper[] objectSerialisationHelpers = Instance.GetComponents<ObjectSerialisationHelper>();
                        objectSerialisationHelpers[0].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = FrontFender;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 1;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            //chair1.AddComponent<BoxCollider2D>();
                            gameObject.AddComponent<Rigidbody2D>().mass = 1f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.frequency = 8f;
                            fixedJoint.dampingRatio = 1f;
                            fixedJoint.breakForce = 1500f;
                            fixedJoint.anchor = new Vector2(0.139f, 0.214f);

                            gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(0.0772174895f,0.24789159f),
                            new Vector2(-0.0916937441f,0.033542484f),
                            new Vector2(-0.153367028f,-0.216425821f),
                            new Vector2(-0.088545233f,-0.241598532f),
                            new Vector2(0.0321439505f,0.0721812248f),
                            new Vector2(0.147994861f,0.192959234f)
                            });

                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rubber");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });                    
                    //1 Front Fender 2
                        objectSerialisationHelpers[1].InstantiateOverride = ((gameObject) =>
                        {        
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = FrontFender2;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 1;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            //chair1.AddComponent<BoxCollider2D>();
                            gameObject.AddComponent<Rigidbody2D>().mass = 1f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.frequency = 8f;
                            fixedJoint.dampingRatio = 2f;
                            fixedJoint.breakForce = 1500f;
                            fixedJoint.anchor = new Vector2(-0.271f, 0.023f);

                            gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(-0.268486023f,0.069592692f),
                            new Vector2(-0.273390293f,-0.0166251436f),
                            new Vector2(-0.0821105242f,0.0187972784f),
                            new Vector2(0.0853084326f,-0.0164974928f),
                            new Vector2(0.203747749f,-0.101961829f),
                            new Vector2(0.272409439f,-0.0356132053f),
                            new Vector2(0.0179837197f,0.100980856f)
                            });

                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rubber");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();                          
                        });
                    //2 Back Fender
                        objectSerialisationHelpers[2].InstantiateOverride = ((gameObject) =>
                        {        
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = BackFender;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 1;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            //chair1.AddComponent<BoxCollider2D>();
                            gameObject.AddComponent<Rigidbody2D>().mass = 1f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.frequency = 8f;
                            fixedJoint.dampingRatio = 2f;
                            fixedJoint.breakForce = 1500f;
                            fixedJoint.anchor = new Vector2(0.3416f, 0.1953f);

                            gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(0.357142866f,0.269001245f),
                            new Vector2(0.0742130205f,0.275069475f),
                            new Vector2(-0.163211271f,0.157242879f),
                            new Vector2(-0.275726438f,0.0143856183f),
                            new Vector2(-0.349020362f,-0.114428401f),
                            new Vector2(-0.359638214f,-0.268691778f),
                            new Vector2(-0.268901348f,-0.270214915f),
                            new Vector2(-0.229310691f,-0.0786367655f),
                            new Vector2(-0.139594451f,0.0625332743f),
                            new Vector2(0.0717877746f,0.172480941f),
                            new Vector2(0.336510301f,0.164881974f)
                            });

                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rubber");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();                          
                        });
                    //3 Back Fender 2
                        objectSerialisationHelpers[3].InstantiateOverride = ((gameObject) =>
                        {        
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = BackFender2;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 1;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            //chair1.AddComponent<BoxCollider2D>();
                            gameObject.AddComponent<Rigidbody2D>().mass = 1f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.frequency = 8f;
                            fixedJoint.dampingRatio = 2f;
                            fixedJoint.breakForce = 1500f;
                            fixedJoint.anchor = new Vector2(-0.0469f, 0.0208f);

                            gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(-0.0523113981f,0.0787608996f),
                            new Vector2(-0.0873437002f,0.0231340192f),
                            new Vector2(0.0498672798f,-0.0787608996f),
                            new Vector2(0.0897877887f,-0.0231339f)
                            });

                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rubber");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();                          
                        });
                    //4 Body
                        objectSerialisationHelpers[4].SerialisationObject = BodyFrame.gameObject;
                        objectSerialisationHelpers[4].InstantiateOverride = ((gameObject) =>
                        {
                            //CarBehaviour beh = BodyFrame.gameObject.GetComponent<CarBehaviour>();
                            //beh.EngineStartup = ModAPI.LoadSound("Sfx/Startup.mp3");
                            //beh.EngineShutoff = ModAPI.LoadSound("Sfx/Shutoff.mp3");
                            //beh.EngineLoop = ModPI.LoadSound("Sfx/Loop.mp3");
                            gameObject.GetComponent<CarBehaviour>().MotorSpeed = MotorSpeed;
                            gameObject.GetComponent<CarBehaviour>().WaterProof = WaterProof;
                            gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            gameObject.GetComponent<SpriteRenderer>().sortingOrder = 5;
                            foreach (Collider2D collider in gameObject.GetComponentsInChildren<Collider2D>())
                                {   
                                    NoCollideWithBodyPart noCollide = gameObject.AddComponent<NoCollideWithBodyPart>();
                                    noCollide.BodyPart = LimbBehaviour.BodyPart.Legs;
                                    noCollide.Collider = collider;
                                }
                            PhysicalBehaviour phys = gameObject.GetComponent<PhysicalBehaviour>();
                            phys.TrueInitialMass = 2f;
                            phys.InitialMass = 2f;
                            phys.rigidbody.mass = 2f;
                            BoxCollider2D[] boxColliders = gameObject.GetComponents<BoxCollider2D>();
                            GameObject.Destroy(boxColliders[0]);
                            GameObject.Destroy(boxColliders[1]);
                            GameObject.Destroy(boxColliders[2]);
                            GameObject.Destroy(boxColliders[3]);
                            PolygonCollider2D collider1 = gameObject.GetComponent<PolygonCollider2D>();
                            collider1.pathCount = 1;
                            collider1.SetPath(0, new Vector2[]
                            {
                            new Vector2(0.938556433f,0.175993994f),
                            new Vector2(0.677660406f,0.700242639f),
                            new Vector2(0.581141472f,0.670809746f),
                            new Vector2(0.700066805f,0.400308609f),
                            new Vector2(0.469714284f,0.512446523f),
                            new Vector2(0.0465953201f,0.514757454f),
                            new Vector2(-0.227331698f,0.377121061f),
                            new Vector2(-1.12366378f,0.398630768f),
                            new Vector2(-1.22082663f,0.172279134f),
                            new Vector2(-0.815399289f,0.136743248f),
                            new Vector2(-1.17459643f,-0.543898046f),
                            new Vector2(-1.04201734f,-0.598376989f),
                            new Vector2(-0.709159791f,0.106118843f),
                            new Vector2(-0.610299826f,-0.139732212f),
                            new Vector2(-0.328336179f,-0.142214149f),
                            new Vector2(-0.144120365f,0.113676205f),
                            new Vector2(0.0182590485f,0.200406641f),
                            new Vector2(0.797033846f,0.204700604f),
                            new Vector2(1.19773507f,-0.606110096f),
                            new Vector2(1.31558096f,-0.553987563f)
                            });
                            //gameObject.AddComponent<Optout>();
                        });
                    //5 Light
                        objectSerialisationHelpers[5].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            body.gameObject.GetComponent<RandomCarTextureBehaviour>().OnAfterChange = new UnityEvent();
                            gameObject.AddComponent<RandomCarTextureChildBehaviour>().Sprites = LightSprites;
                            //chair1Renderer.sprite = Light;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 1;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            //chair1.AddComponent<BoxCollider2D>();
                            gameObject.AddComponent<Rigidbody2D>().mass = 1f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.anchor = new Vector2(-0.101f, -0.05f);
                            fixedJoint.frequency = 25f;
                            fixedJoint.dampingRatio = 5f;
                            fixedJoint.breakForce = 5000f;
                            
                            gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(0.0276281834f,0.214452267f),
                            new Vector2(-0.0275788307f,0.214558363f),
                            new Vector2(-0.115581043f,0.100296602f),
                            new Vector2(-0.112990148f,-0.0990012735f),
                            new Vector2(-0.0332603455f,-0.214041591f),
                            new Vector2(0.0299363136f,-0.213851094f),
                            new Vector2(0.116876371f,-0.0977058262f),
                            new Vector2(0.114285715f,0.0964106172f)
                            });

                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });              
                    //Wheels
                        WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        if(firstSpawn)
                        {
                            wheels[0].connectedBody.gameObject.transform.localPosition = new Vector2(-1.0864f, -0.5307f);
                        }  
                        wheels[0].suspension = new JointSuspension2D()
                        {
                            frequency = 8f,
                            angle = 65f,
                            dampingRatio = 0.7f
                        };
                        wheels[0].anchor = new Vector2(-1.0864f, -0.5307f);
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel;
                        wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.3857143f;
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder = -1;
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                        
                        if(firstSpawn)
                        {
                            wheels[1].connectedBody.gameObject.transform.localPosition = new Vector2(1.228f, -0.5307f);
                        }  
                        wheels[1].suspension = new JointSuspension2D()
                        {
                            frequency = 10f,
                            angle = 114f,
                            dampingRatio = 0.7f
                        };
                        wheels[1].anchor = new Vector2(1.228f, -0.5307f);
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel;
                        wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.3857143f;  
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder = -1;
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Default";   
                        //List<WheelJoint2D> wheelss = body.GetComponent<CarBehaviour>().WheelJoints.ToList();
                        //wheelss.RemoveAt(1);
                        //body.GetComponent<CarBehaviour>().WheelJoints = wheelss.ToArray(); 
                    //SerialisationSettings
                        if(firstSpawn)
                        {
                            objectSerialisationHelpers[0].InstantiateOverride(objectSerialisationHelpers[0].SerialisationObject);
                            objectSerialisationHelpers[1].InstantiateOverride(objectSerialisationHelpers[1].SerialisationObject);
                            objectSerialisationHelpers[2].InstantiateOverride(objectSerialisationHelpers[2].SerialisationObject);
                            objectSerialisationHelpers[3].InstantiateOverride(objectSerialisationHelpers[3].SerialisationObject);
                            objectSerialisationHelpers[4].InstantiateOverride(objectSerialisationHelpers[4].SerialisationObject);
                            objectSerialisationHelpers[5].InstantiateOverride(objectSerialisationHelpers[5].SerialisationObject);
                        } 
                // 
                                    
                    }
                }
            );
    
    //Filipino Tricicle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Filipino Tricicle",
                    NameToOrderByOverride = "MoreVehicles",
                    DescriptionOverride = "Filipino Tricicle. Uh, just.... Uh... Enjoy the ride!",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Filipino Trycicle.png"), 
                    AfterSpawn = (Instance) =>
                    {
                //Main
                        Sprite Mirror = ModAPI.LoadSprite("Textures/NSR Truck/Mirror.png");
                        Sprite CabinBackground = ModAPI.LoadSprite("Textures/NSR Truck/CabinBackground.png");
                        Sprite Wheel = ModAPI.LoadSprite("Textures/Motorcycle/Wheel.png");
                        Sprite GasTankSprite = ModAPI.LoadSprite("Textures/Motorcycle/Gas Tank.png");
                        Sprite EngineSprite = ModAPI.LoadSprite("Textures/Motorcycle/Engine.png");

                        Sprite FrontFender = ModAPI.LoadSprite("Textures/Motorcycle/FrontFender.png");
                        Sprite FrontFender2 = ModAPI.LoadSprite("Textures/Motorcycle/FrontFender2.png");
                        Sprite BackFender = ModAPI.LoadSprite("Textures/Motorcycle/BackFender.png");
                        Sprite BackFender2 = ModAPI.LoadSprite("Textures/Motorcycle/BackFender2.png");
                        Sprite Light = ModAPI.LoadSprite("Textures/Motorcycle/Light.png");

                        Sprite MotorcycleBody2 = ModAPI.LoadSprite("Textures/Motorcycle/Filipino Trycicle/Motorcycle Body2.png");
                        Sprite TrycicleBody = ModAPI.LoadSprite("Textures/Motorcycle/Filipino Trycicle/Body.png");
                        Sprite TrycicleBackground = ModAPI.LoadSprite("Textures/Motorcycle/Filipino Trycicle/Background.png");
                        Sprite Chair = ModAPI.LoadSprite("Textures/Motorcycle/Filipino Trycicle/Chair.png");

                        AudioClip Horn = ModAPI.LoadSound("Sfx/Truck Horn.mp3");
                        AudioClip ButtonOffSound = ModAPI.LoadSound("Sfx/ButtonOff.mp3");
                        AudioClip ButtonOnSound = ModAPI.LoadSound("Sfx/ButtonOn.mp3");

                        float MotorSpeed = -2000f;
                        bool WaterProof = false;
                       
                        var body = Instance.transform.GetChild(0);
                        bool firstSpawn = (body.localPosition == Vector3.zero);                       
                        var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite1.Body = ModAPI.LoadSprite("Textures/Motorcycle/Filipino Trycicle/Motorcycle Body.png");
                        CarSprite1.Background = ModAPI.LoadSprite("Textures/Motorcycle/None.png");

                        Instance.transform.GetChild(5).gameObject.SetActive(false);
                        Instance.transform.GetChild(3).gameObject.SetActive(false);
                        Instance.transform.GetChild(4).gameObject.SetActive(false);
                        Instance.transform.GetChild(6).gameObject.SetActive(false); //Back Door
                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingOrder = 5;
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().chosenIndex = UnityEngine.Random.Range(0, 3);
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[] 
                        {
                            CarSprite1
                        };                      
                //Settings
                    //GameObjects
                        Transform BodyFrame = Instance.transform.GetChild(0);                    

                        if(firstSpawn)
                        {                                          
                            GameObject FrontFenderObj = new GameObject("Front Fender");
                            FrontFenderObj.transform.parent = Instance.transform;
                            FrontFenderObj.transform.rotation = BodyFrame.rotation;
                            FrontFenderObj.transform.localScale = Vector3.one;
                            FrontFenderObj.transform.localPosition = new Vector3(0.827f, -0.356f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = FrontFenderObj;

                            GameObject FrontFenderObj2 = new GameObject("Front Fender 2");
                            FrontFenderObj2.transform.parent = Instance.transform;
                            FrontFenderObj2.transform.rotation = BodyFrame.rotation;
                            FrontFenderObj2.transform.localScale = Vector3.one;
                            FrontFenderObj2.transform.localPosition = new Vector3(1.314f, -0.099f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = FrontFenderObj2;

                            BodyFrame.localPosition = Vector3.zero;
                            BodyFrame.gameObject.name = "Body";
                            //frame.gameObject.AddComponent<Optout>();
                            Instance.AddComponent<ObjectSerialisationHelper>(); 

                            GameObject LightObj = new GameObject("Light");
                            LightObj.transform.parent = Instance.transform;
                            LightObj.transform.rotation = BodyFrame.rotation;
                            LightObj.transform.localScale = Vector3.one;
                            LightObj.transform.localPosition = new Vector3(0.954f, 0.418f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = LightObj;

                            GameObject TrycicleBodyObj = new GameObject("Trycicle Body");
                            TrycicleBodyObj.transform.parent = BodyFrame;
                            TrycicleBodyObj.transform.rotation = BodyFrame.rotation;
                            TrycicleBodyObj.transform.localScale = Vector3.one;
                            TrycicleBodyObj.transform.localPosition = new Vector3(-1.075f, 0.596f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = TrycicleBodyObj;

                            GameObject MotorcycleBody2Obj = new GameObject("Motorcycle Body 2");
                            MotorcycleBody2Obj.transform.parent = BodyFrame;
                            MotorcycleBody2Obj.transform.rotation = BodyFrame.rotation;
                            MotorcycleBody2Obj.transform.localScale = Vector3.one;
                            MotorcycleBody2Obj.transform.localPosition = new Vector3(0f, 0f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = MotorcycleBody2Obj; 

                            GameObject ChairObj = new GameObject("Chair");
                            ChairObj.transform.parent = Instance.transform;
                            ChairObj.transform.rotation = BodyFrame.rotation;
                            ChairObj.transform.localScale = Vector3.one;
                            ChairObj.transform.localPosition = new Vector3(-1.588f, 0.024f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = ChairObj;                       
                        }                                             
                    //Engine&Gas Tank
                        var engine = Instance.transform.GetChild(7);
                        engine.localScale = new Vector3(1f, 1f);
                        if(firstSpawn)
                        {
                            engine.localPosition = new Vector3(-0.007f, 0.003f);
                        }
                        GameObject.Destroy(engine.gameObject.GetComponent<BoxCollider2D>());
                        Instance.transform.GetChild(7).gameObject.AddComponent<CircleCollider2D>();
                        Instance.transform.GetChild(7).gameObject.GetComponent<CircleCollider2D>().radius = 0.2f;
                        Instance.transform.GetChild(7).gameObject.GetComponent<SpriteRenderer>().sprite = EngineSprite;
                        Instance.transform.GetChild(7).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                        foreach (Collider2D collider in Instance.transform.GetChild(7).gameObject.GetComponentsInChildren<Collider2D>())
                                {   
                                    NoCollideWithBodyPart noCollide = Instance.transform.GetChild(7).gameObject.AddComponent<NoCollideWithBodyPart>();
                                    noCollide.BodyPart = LimbBehaviour.BodyPart.Legs;
                                    noCollide.Collider = collider;
                                }

                        var GasTank = Instance.transform.GetChild(8);
                        GasTank.localScale = new Vector3(1f, 1f);
                        if(firstSpawn)
                        {
                            GasTank.localPosition = new Vector3(0.431f, 0.034f);
                        }
                        GameObject.Destroy(GasTank.gameObject.GetComponent<BoxCollider2D>());
                        Instance.transform.GetChild(8).gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                                new Vector2(-0.300000012f,0.157142863f),
                                new Vector2(-0.300000012f,-0.157142863f),
                                new Vector2(0.130043849f,-0.157142863f),
                                new Vector2(0.298886597f,0.0116999f),
                                new Vector2(0.271032572f,0.127796769f),
                                new Vector2(0.0706378222f,0.157142863f)
                            });
                        Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sprite = GasTankSprite;
                        Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                        foreach (Collider2D collider in Instance.transform.GetChild(8).gameObject.GetComponentsInChildren<Collider2D>())
                                {   
                                    NoCollideWithBodyPart noCollide = Instance.transform.GetChild(8).gameObject.AddComponent<NoCollideWithBodyPart>();
                                    noCollide.BodyPart = LimbBehaviour.BodyPart.Legs;
                                    noCollide.Collider = collider;
                                }
                        
                    //0 Front Fender
                        ObjectSerialisationHelper[] objectSerialisationHelpers = Instance.GetComponents<ObjectSerialisationHelper>();
                        objectSerialisationHelpers[0].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = FrontFender;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 1;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            //chair1.AddComponent<BoxCollider2D>();
                            gameObject.AddComponent<Rigidbody2D>().mass = 1f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.frequency = 8f;
                            fixedJoint.dampingRatio = 1f;
                            fixedJoint.breakForce = 1500f;
                            fixedJoint.anchor = new Vector2(0.139f, 0.214f);

                            gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(0.0772174895f,0.24789159f),
                            new Vector2(-0.0916937441f,0.033542484f),
                            new Vector2(-0.153367028f,-0.216425821f),
                            new Vector2(-0.088545233f,-0.241598532f),
                            new Vector2(0.0321439505f,0.0721812248f),
                            new Vector2(0.147994861f,0.192959234f)
                            });

                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rubber");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });                    
                    //1 Front Fender 2
                        objectSerialisationHelpers[1].InstantiateOverride = ((gameObject) =>
                        {        
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = FrontFender2;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 1;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            //chair1.AddComponent<BoxCollider2D>();
                            gameObject.AddComponent<Rigidbody2D>().mass = 1f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.frequency = 8f;
                            fixedJoint.dampingRatio = 2f;
                            fixedJoint.breakForce = 1500f;
                            fixedJoint.anchor = new Vector2(-0.271f, 0.023f);

                            gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(-0.268486023f,0.069592692f),
                            new Vector2(-0.273390293f,-0.0166251436f),
                            new Vector2(-0.0821105242f,0.0187972784f),
                            new Vector2(0.0853084326f,-0.0164974928f),
                            new Vector2(0.203747749f,-0.101961829f),
                            new Vector2(0.272409439f,-0.0356132053f),
                            new Vector2(0.0179837197f,0.100980856f)
                            });

                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rubber");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();                          
                        });
                    //2 Body
                        objectSerialisationHelpers[2].SerialisationObject = BodyFrame.gameObject;
                        objectSerialisationHelpers[2].InstantiateOverride = ((gameObject) =>
                        {
                            //CarBehaviour beh = BodyFrame.gameObject.GetComponent<CarBehaviour>();
                            //beh.EngineStartup = ModAPI.LoadSound("Sfx/Startup.mp3");
                            //beh.EngineShutoff = ModAPI.LoadSound("Sfx/Shutoff.mp3");
                            //beh.EngineLoop = ModPI.LoadSound("Sfx/Loop.mp3");
                            gameObject.GetComponent<CarBehaviour>().MotorSpeed = MotorSpeed;
                            gameObject.GetComponent<CarBehaviour>().WaterProof = WaterProof;
                            gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            gameObject.GetComponent<SpriteRenderer>().sortingOrder = 5;
                            foreach (Collider2D collider in gameObject.GetComponentsInChildren<Collider2D>())
                                {   
                                    NoCollideWithBodyPart noCollide = gameObject.AddComponent<NoCollideWithBodyPart>();
                                    noCollide.BodyPart = LimbBehaviour.BodyPart.Legs;
                                    noCollide.Collider = collider;
                                }
                            PhysicalBehaviour phys = gameObject.GetComponent<PhysicalBehaviour>();
                            phys.TrueInitialMass = 4f;
                            phys.InitialMass = 4f;
                            phys.rigidbody.mass = 4f;
                            BoxCollider2D[] boxColliders = gameObject.GetComponents<BoxCollider2D>();
                            GameObject.Destroy(boxColliders[0]);
                            GameObject.Destroy(boxColliders[1]);
                            GameObject.Destroy(boxColliders[2]);
                            GameObject.Destroy(boxColliders[3]);
                            PolygonCollider2D collider1 = gameObject.GetComponent<PolygonCollider2D>();
                            collider1.pathCount = 1;
                            collider1.SetPath(0, new Vector2[]
                            {
                            new Vector2(0.938556433f,0.175993994f),
                            new Vector2(0.677660406f,0.700242639f),
                            new Vector2(0.581141472f,0.670809746f),
                            new Vector2(0.700066805f,0.400308609f),
                            new Vector2(0.469714284f,0.512446523f),
                            new Vector2(0.0465953201f,0.514757454f),
                            new Vector2(-0.227331698f,0.377121061f),
                            new Vector2(-1.04691327f,0.398630768f),
                            new Vector2(-0.977782965f,0.152177781f),
                            new Vector2(-0.577837825f,0.129433662f),
                            new Vector2(-0.487864256f,-0.14338699f),
                            new Vector2(-0.328336179f,-0.142214149f),
                            new Vector2(-0.144120365f,0.113676205f),
                            new Vector2(0.0182590485f,0.200406641f),
                            new Vector2(0.797033846f,0.204700604f),
                            new Vector2(1.19773507f,-0.606110096f),
                            new Vector2(1.31558096f,-0.553987563f)
                            });
                            //gameObject.AddComponent<Optout>();
                        });
                    //3 Light
                        objectSerialisationHelpers[3].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = Light;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 1;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            //chair1.AddComponent<BoxCollider2D>();
                            gameObject.AddComponent<Rigidbody2D>().mass = 1f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.anchor = new Vector2(-0.101f, -0.05f);
                            fixedJoint.frequency = 25f;
                            fixedJoint.dampingRatio = 5f;
                            fixedJoint.breakForce = 5000f;
                            
                            gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(0.0276281834f,0.214452267f),
                            new Vector2(-0.0275788307f,0.214558363f),
                            new Vector2(-0.115581043f,0.100296602f),
                            new Vector2(-0.112990148f,-0.0990012735f),
                            new Vector2(-0.0332603455f,-0.214041591f),
                            new Vector2(0.0299363136f,-0.213851094f),
                            new Vector2(0.116876371f,-0.0977058262f),
                            new Vector2(0.114285715f,0.0964106172f)
                            });

                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });
                    //4 Trycicle Body
                        objectSerialisationHelpers[4].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = TrycicleBody;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 6;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            //chair1.AddComponent<BoxCollider2D>();
                            gameObject.AddComponent<Rigidbody2D>().mass = 1f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            //fixedJoint.anchor = new Vector2(-0.101f, -0.05f);
                            //fixedJoint.frequency = 25f;
                            //fixedJoint.dampingRatio = 5f;
                            //fixedJoint.breakForce = 5000f;                        
                            gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(-0.856763244f,1.16979635f),
                            new Vector2(-1.1269033f,0.204314411f),
                            new Vector2(-1.12608671f,-0.207771033f),
                            new Vector2(-0.725970387f,-1.16276741f),
                            new Vector2(0.677913368f,-1.15264821f),
                            new Vector2(0.665659845f,-1.07439184f),
                            new Vector2(-0.699467063f,-1.07142222f),
                            new Vector2(-1.01060963f,-0.137491316f),
                            new Vector2(-1.00834894f,0.248396337f),
                            new Vector2(-0.776093066f,0.925756514f),
                            new Vector2(0.570355356f,0.931275606f),
                            new Vector2(0.758990645f,1.08659768f),
                            new Vector2(0.489776373f,1.15888596f)
                            });
                            gameObject.GetComponent<PolygonCollider2D>().pathCount = 1;

                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();

                            GameObject TrycicleBackgrounObj = new GameObject("Trycicle Background");
                            TrycicleBackgrounObj.transform.parent = gameObject.transform;
                            TrycicleBackgrounObj.transform.rotation = BodyFrame.rotation;
                            TrycicleBackgrounObj.transform.localScale = Vector3.one;
                            TrycicleBackgrounObj.transform.localPosition = new Vector3(0f, 0f);
                            SpriteRenderer chair2Renderer = TrycicleBackgrounObj.AddComponent<SpriteRenderer>();
                            chair2Renderer.sprite = TrycicleBackground;
                            chair2Renderer.sortingLayerName = "Bottom";
                            chair2Renderer.sortingOrder = -7;
                            
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });
                    //5 Motorcycle Body 2
                        objectSerialisationHelpers[5].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = MotorcycleBody2;
                            chair1Renderer.sortingLayerName = "Bottom";
                            chair1Renderer.sortingOrder = -8;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            //chair1.AddComponent<BoxCollider2D>();
                            gameObject.AddComponent<Rigidbody2D>().mass = 0f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();

                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });
                    //6 Chair
                        objectSerialisationHelpers[6].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = Chair;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 5;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            gameObject.AddComponent<Rigidbody2D>().mass = 0.2f;

                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = BodyFrame.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.breakForce = 2000f;

                            gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                            new Vector2(-0.177391648f,0.505213141f),
                            new Vector2(-0.307724714f,0.494143993f),
                            new Vector2(-0.326942801f,0.24908267f),
                            new Vector2(-0.245497823f,-0.195290446f),
                            new Vector2(-0.183290958f,-0.500948668f),
                            new Vector2(0.21572268f,-0.500665426f),
                            new Vector2(0.326414347f,-0.185063392f),
                            new Vector2(0.297913194f,-0.0695647448f),
                            new Vector2(-0.0751104504f,-0.0705380142f)
                            });

                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });               
                    //Wheels
                        WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        if(firstSpawn)
                        {
                            wheels[0].connectedBody.gameObject.transform.localPosition = new Vector2(-1.0864f, -0.5307f);
                        }  
                        wheels[0].suspension = new JointSuspension2D()
                        {
                            frequency = 13f,
                            angle = 65f,
                            dampingRatio = 1f
                        };
                        wheels[0].anchor = new Vector2(-1.0864f, -0.5307f);
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel;
                        wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.3857143f;
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder = -9;
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";

                        foreach (Collider2D collider in wheels[0].connectedBody.gameObject.GetComponentsInChildren<Collider2D>())
                                {   
                                    NoCollideWithBodyPart noCollide = wheels[0].connectedBody.gameObject.AddComponent<NoCollideWithBodyPart>();
                                    noCollide.BodyPart = LimbBehaviour.BodyPart.Legs;
                                    noCollide.Collider = collider;
                                }
                            foreach (Collider2D collider2 in wheels[0].connectedBody.gameObject.GetComponentsInChildren<Collider2D>())
                                {   
                                    NoCollideWithBodyPart noCollide = wheels[0].connectedBody.gameObject.AddComponent<NoCollideWithBodyPart>();
                                    noCollide.BodyPart = LimbBehaviour.BodyPart.Torso;
                                    noCollide.Collider = collider2;
                                }
                        
                        if(firstSpawn)
                        {
                            wheels[1].connectedBody.gameObject.transform.localPosition = new Vector2(1.228f, -0.5307f);
                        }  
                        wheels[1].suspension = new JointSuspension2D()
                        {
                            frequency = 13f,
                            angle = 114f,
                            dampingRatio = 1f
                        };
                        wheels[1].anchor = new Vector2(1.228f, -0.5307f);
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel;
                        wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.3857143f;  
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder = -1;
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Default";    
                    //SerialisationSettings
                        if(firstSpawn)
                        {
                            objectSerialisationHelpers[0].InstantiateOverride(objectSerialisationHelpers[0].SerialisationObject);
                            objectSerialisationHelpers[1].InstantiateOverride(objectSerialisationHelpers[1].SerialisationObject);
                            objectSerialisationHelpers[2].InstantiateOverride(objectSerialisationHelpers[2].SerialisationObject);
                            objectSerialisationHelpers[3].InstantiateOverride(objectSerialisationHelpers[3].SerialisationObject);
                            objectSerialisationHelpers[4].InstantiateOverride(objectSerialisationHelpers[4].SerialisationObject);
                            objectSerialisationHelpers[5].InstantiateOverride(objectSerialisationHelpers[5].SerialisationObject);
                            objectSerialisationHelpers[6].InstantiateOverride(objectSerialisationHelpers[6].SerialisationObject);
                        } 
                //                                  
                    }
                }
            );
    
    //Tractor
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Tractor",
                    NameToOrderByOverride = "MoreVehicles",
                    DescriptionOverride = "Slow tractor. Maximum height of the driver - 0.8m",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Tractor.png"), 
                    AfterSpawn = (Instance) =>
                    {
                //Main
                        Sprite Chair = ModAPI.LoadSprite("Textures/Tractor/Chair2.png");
                        Sprite Background2 = ModAPI.LoadSprite("Textures/Tractor/Background2.png");
                        Sprite Wheel1 = ModAPI.LoadSprite("Textures/Tractor/Big Wheel.png");
                        Sprite Wheel2 = ModAPI.LoadSprite("Textures/Tractor/Small Wheel.png");
                        float MotorSpeed = -250f;
                        bool WaterProof = true;

                        var body = Instance.transform.GetChild(0);
                        bool firstSpawn = (body.localPosition == Vector3.zero);                       
                        var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite1.Body = ModAPI.LoadSprite("Textures/Tractor/Body.png");
                        CarSprite1.Background = ModAPI.LoadSprite("Textures/Tractor/Background.png");
                        CarSprite1.FrontDoor = ModAPI.LoadSprite("Textures/Tractor/Door.png");
                        CarSprite1.BackDoor = ModAPI.LoadSprite("Textures/Tractor/Door.png");
                        CarSprite1.Bonnet = ModAPI.LoadSprite("Textures/Tractor/Bonnet.png");

                        var CarSprite2 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite2.Body = ModAPI.LoadSprite("Textures/Tractor/Yellow/Body.png");
                        CarSprite2.Background = ModAPI.LoadSprite("Textures/Tractor/Yellow/Background.png");
                        CarSprite2.FrontDoor = ModAPI.LoadSprite("Textures/Tractor/Door.png");
                        CarSprite2.BackDoor = ModAPI.LoadSprite("Textures/Tractor/Door.png");
                        CarSprite2.Bonnet = ModAPI.LoadSprite("Textures/Tractor/Yellow/Bonnet.png");

                        var CarSprite3 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite3.Body = ModAPI.LoadSprite("Textures/Tractor/Broken/Body.png");
                        CarSprite3.Background = ModAPI.LoadSprite("Textures/Tractor/Broken/Background.png");
                        CarSprite3.FrontDoor = ModAPI.LoadSprite("Textures/Tractor/Broken/Door.png");
                        CarSprite3.BackDoor = ModAPI.LoadSprite("Textures/Tractor/Door.png");
                        CarSprite3.Bonnet = ModAPI.LoadSprite("Textures/Tractor/Broken/Bonnet.png");

                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingOrder = 5;
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().chosenIndex = UnityEngine.Random.Range(0, 3);
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[] 
                        {
                            CarSprite1,
                            CarSprite2,
                            CarSprite3
                        };                      
                //Settings
                        if(firstSpawn)
                        {
                            GameObject chair1 = new GameObject("Chair 1");
                            chair1.transform.parent = Instance.transform;
                            chair1.transform.localScale = Vector3.one;
                            chair1.transform.localPosition = new Vector3(-0.676f, 0.129f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = chair1;

                            GameObject Bodyup = new GameObject("Body2");
                            Bodyup.transform.parent = Instance.transform;
                            Bodyup.transform.localScale = Vector3.one;
                            Bodyup.transform.localPosition = new Vector3(0f, 0f); 
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = Bodyup;
                        }
                    //Body      
                        if (firstSpawn)
                        {
                            body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = MotorSpeed;
                            body.gameObject.GetComponent<CarBehaviour>().WaterProof = WaterProof; 
                        }                                       
                        body.GetComponent<PolygonCollider2D>().pathCount = 2;
                        body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(0.671237946f,0.586121202f),
                            new Vector2(0.276311755f,0.595907271f),
                            new Vector2(0.278191626f,1.35058725f),
                            new Vector2(0.333479762f,1.35465777f),
                            new Vector2(0.299787372f,1.49792409f),
                            new Vector2(-1.27561867f,1.5011512f),
                            new Vector2(-1.30210316f,1.35262835f),
                            new Vector2(-1.27505136f,1.32455063f),
                            new Vector2(-1.27067149f,1.01681781f),
                            new Vector2(-1.30069339f,1.01364172f),
                            new Vector2(-1.30230045f,0.673768401f),
                            new Vector2(-1.32668662f,0.670561671f),
                            new Vector2(-1.33252764f,0.331430942f),
                            new Vector2(-1.58562398f,0.331357718f),
                            new Vector2(-1.58713007f,0.239980459f),
                            new Vector2(-1.32973599f,0.244569495f),
                            new Vector2(-1.32872987f,-0.0690284371f),
                            new Vector2(-1.15337753f,-0.414788365f),
                            new Vector2(-0.92498517f,-0.529495776f),
                            new Vector2(-0.445107877f,-0.530214489f),
                            new Vector2(-0.443457484f,-0.584004641f),
                            new Vector2(-0.358813107f,-0.584108472f),
                            new Vector2(-0.355927974f,-0.524684429f),
                            new Vector2(0.18240568f,-0.52665025f),
                            new Vector2(0.185097665f,-0.58128345f),
                            new Vector2(0.306797624f,-0.671058655f),
                            new Vector2(0.819960713f,-0.67579633f),
                            new Vector2(0.816046178f,-0.954868853f),
                            new Vector2(0.904327989f,-0.953218341f),
                            new Vector2(0.905614495f,-0.676502287f),
                            new Vector2(1.0197506f,-0.452649951f),
                            new Vector2(1.29654419f,-0.228157222f),
                            new Vector2(1.67730415f,-0.128672898f),
                            new Vector2(2.04187536f,-0.214909613f),
                            new Vector2(2.24207473f,-0.498955667f),
                            new Vector2(2.21824884f,-0.27132386f),
                            new Vector2(2.21526909f,0.186229259f),
                            new Vector2(0.671206951f,0.186790615f)                     
                        });
                        body.gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
                        {
                            new Vector2(-1.08345056f,-0.315188438f), 
                            new Vector2(-1.22759151f,-0.151488289f), 
                            new Vector2(-1.23919761f,0.328147829f), 
                            new Vector2(-1.18459749f,1.42672908f), 
                            new Vector2(0.186343372f,1.42446315f), 
                            new Vector2(0.187714219f,-0.440303802f), 
                            new Vector2(-0.918489218f,-0.436653674f)
                        });
                        Instance.transform.GetChild(0).GetChild(0).localPosition = Vector3.zero;
                        foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            {
                                GameObject.Destroy(boxCollider);
                            }
                    //Wheels
                        WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        if(firstSpawn)
                        {
                            wheels[0].connectedBody.gameObject.transform.localPosition = new Vector2(-1.428f, -0.6592f);
                        }  
                        wheels[0].anchor = new Vector2(-1.428f, -0.6592f);
                        wheels[0].suspension = new JointSuspension2D()
                        {
                            frequency = 14f,
                            angle = 90f,
                            dampingRatio = 1f
                        };
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel1;
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 3;
                        wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.8428571f;
                        
                        if(firstSpawn)
                        {
                            wheels[1].connectedBody.gameObject.transform.localPosition = new Vector2(1.6289f, -0.915f);
                        }  
                        wheels[1].anchor = new Vector2(1.6289f, -0.915f); //-0.8586
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel2;
                        wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.6428571f;
                    //Front Door
                        var frontDoor = Instance.transform.GetChild(5);
                        if(firstSpawn)
                        {
                            frontDoor.localPosition = new Vector3(-0.271f, 0.413f);
                        }                       
                        Instance.transform.GetChild(5).gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.54285717f,0.942857146f),
                            new Vector2(-0.544883609f,-0.164130837f),
                            new Vector2(-0.470748156f,-0.209769085f),
                            new Vector2(-0.327474087f,-0.485711157f),
                            new Vector2(-0.166135326f,-0.940544665f),
                            new Vector2(0.54285717f,-0.942857146f),
                            new Vector2(0.54285717f,0.942857146f)
                        });
                        Instance.transform.GetChild(5).gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
                        {
                            new Vector2(0.455191106f,-0.857136786f),
                            new Vector2(-0.112480193f,-0.853988945f),
                            new Vector2(-0.220769942f,-0.495190233f),
                            new Vector2(-0.453954071f,-0.1187874f),
                            new Vector2(-0.456170231f,0.886436403f),
                            new Vector2(0.461254686f,0.882796228f)
                        });
                        frontDoor.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(0.228f, 0.413f);
                        frontDoor.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 6;
                        frontDoor.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";  
                    //Back Door
                        var backDoor = Instance.transform.GetChild(6);
                        if(firstSpawn)
                        {
                            backDoor.localPosition = new Vector3(2.4285f, 0.12855f);
                        }
                        backDoor.gameObject.AddComponent<BoxCollider2D>().size = new Vector2(0.6285715f, 2.457143f);
                        backDoor.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.33f, 0f);
                        GameObject.Destroy(backDoor.gameObject.GetComponent<PolygonCollider2D>());
                        Instance.transform.GetChild(6).gameObject.SetActive(false);
                    //Bonnet
                        var bonnet = Instance.transform.GetChild(3);
                        bonnet.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        bonnet.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 2;
                        //bonnet.gameObject.GetComponent<SpriteRenderer>().sortingOrder = wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        bonnet.gameObject.GetComponent<FixedJoint2D>().breakForce = 300f;
                        bonnet.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.7719f, 0.1835f);
                        var limits = new JointAngleLimits2D();
                        limits.min = -65;
                        limits.max = 0;
                        bonnet.gameObject.GetComponent<HingeJoint2D>().limits = limits;
                        if(firstSpawn)
                        {
                            bonnet.localPosition = new Vector3(1.4425f, 0.3857f);
                        }
                        bonnet.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.744668961f,0.199194193f),
                            new Vector2(-0.771428585f,0.200000003f),
                            new Vector2(-0.771428585f,-0.200000003f),
                            new Vector2(-0.743995667f,-0.200000003f),
                            new Vector2(-0.745420456f,0.16996865f),
                            new Vector2(0.742544174f,0.0808310658f),
                            new Vector2(0.74133873f,-0.20101735f),
                            new Vector2(0.770750046f,-0.201362044f),
                            new Vector2(0.769486904f,0.0803557485f),
                            new Vector2(0.771428585f,0.113803282f)
                        });
                    //Boot
                        Instance.transform.GetChild(4).gameObject.SetActive(false);
                    //Engine
                        var engine = Instance.transform.GetChild(7);
                        engine.localScale = new Vector3(0.9f, 0.9f);
                        if(firstSpawn)
                        {
                            engine.localPosition = new Vector3(1.132f, 0.158f);
                        }
                        Instance.transform.GetChild(7).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.transform.GetChild(7).gameObject.GetComponent<SpriteRenderer>().sortingOrder = 1;
                    //Gas Tank
                        var GasTank = Instance.transform.GetChild(8);
                        GasTank.localScale = new Vector3(0.9f, 0.9f);
                        if(firstSpawn)
                        {
                            GasTank.localPosition = new Vector3(0.773f, -0.355f);
                        }
                        GameObject.Destroy(GasTank.gameObject.GetComponent<BoxCollider2D>());
                        Instance.transform.GetChild(8).gameObject.AddComponent<BoxCollider2D>();
                        //Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vechicle/Tractor/Gas Tank.png");
                        //Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
                    //Chair
                        ObjectSerialisationHelper[] objectSerialisationHelpers = Instance.GetComponents<ObjectSerialisationHelper>();
                        objectSerialisationHelpers[0].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = Chair;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 4;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            //chair1.AddComponent<BoxCollider2D>();
                            gameObject.AddComponent<Rigidbody2D>().mass = 1f;
                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.breakForce = 4000f;
                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                                new Vector2(-0.371428579f,0.571428597f),
                                new Vector2(-0.252832115f,-0.570130467f),
                                new Vector2(0.143671647f,-0.572653174f),
                                new Vector2(0.163793921f,-0.403702319f),
                                new Vector2(0.273466289f,-0.263672799f),
                                new Vector2(0.28938517f,-0.0555137806f),
                                new Vector2(-0.117217183f,-0.0584296882f),
                                new Vector2(-0.193288937f,0.571428597f)               
                            });
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });
                    //Background2
                        objectSerialisationHelpers[1].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer BodyupRenderer = gameObject.AddComponent<SpriteRenderer>();
                            BodyupRenderer.sprite = Background2;
                            BodyupRenderer.sortingLayerName = "Foreground";
                            BodyupRenderer.sortingOrder = 2;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            gameObject.AddComponent<Rigidbody2D>().mass = 3f;
                            FixedJoint2D fixedJointBodyup = gameObject.AddComponent<FixedJoint2D>();
                            fixedJointBodyup.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                            fixedJointBodyup.breakForce = 10000f;
                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            var Body2Collider = gameObject.AddComponent<PolygonCollider2D>();
                            Body2Collider.pathCount = 1;
                            Body2Collider.SetPath(0, new Vector2[]
                            {
                                new Vector2(-1.32989931f,0.245258451f),
                                new Vector2(-1.31401157f,-0.119970784f),
                                new Vector2(-1.1847837f,-0.373874247f),
                                new Vector2(-0.935878336f,-0.51474005f),
                                new Vector2(-0.444180042f,-0.527248561f),
                                new Vector2(-0.445675671f,-0.44495818f),
                                new Vector2(-0.89308852f,-0.432906836f),
                                new Vector2(-1.14483106f,-0.268992245f),
                                new Vector2(-1.2331506f,-0.0274081677f),
                                new Vector2(-1.23865211f,0.245118275f)         
                            });
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });
                    //SerialisationSettings
                        if(firstSpawn)
                        {
                            objectSerialisationHelpers[0].InstantiateOverride(objectSerialisationHelpers[0].SerialisationObject);
                            objectSerialisationHelpers[1].InstantiateOverride(objectSerialisationHelpers[1].SerialisationObject);
                        } 
                // 
                                    
                    }
                }
            );  
    //Roadroller
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Roadroller",
                    NameToOrderByOverride = "MoreVehicles",
                    DescriptionOverride = "Whoa. The front wheel is VERY heavy... It could probably run over a human being...",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Roadroller.png"), 
                    AfterSpawn = (Instance) =>
                    {
                //Main
                        Sprite Chair = ModAPI.LoadSprite("Textures/Roadroller/Chair.png");
                        Sprite Tube = ModAPI.LoadSprite("Textures/Roadroller/Tube.png");
                        Sprite Lamp = ModAPI.LoadSprite("Textures/Roadroller/Lamp.png");
                        Sprite Wheel1 = ModAPI.LoadSprite("Textures/Roadroller/Wheel2.png");
                        Sprite Wheel2 = ModAPI.LoadSprite("Textures/Roadroller/Wheel.png");
                        float MotorSpeed = -300f;
                        bool WaterProof = false;

                        var body = Instance.transform.GetChild(0);
                        bool firstSpawn = (body.localPosition == Vector3.zero);                       
                        var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite1.Body = ModAPI.LoadSprite("Textures/Roadroller/Original/Body.png");
                        CarSprite1.Background = ModAPI.LoadSprite("Textures/Roadroller/Original/Background.png");
                        CarSprite1.FrontDoor = ModAPI.LoadSprite("Textures/Roadroller/Original/Door.png");
                        CarSprite1.Bonnet = ModAPI.LoadSprite("Textures/Roadroller/Original/Bonnet.png"); 

                        var CarSprite2 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite2.Body = ModAPI.LoadSprite("Textures/Roadroller/Blue/Body.png");
                        CarSprite2.Background = ModAPI.LoadSprite("Textures/Roadroller/Blue/Background.png");
                        CarSprite2.FrontDoor = ModAPI.LoadSprite("Textures/Roadroller/Blue/Door.png");
                        CarSprite2.Bonnet = ModAPI.LoadSprite("Textures/Roadroller/Blue/Bonnet.png");

                        var CarSprite3 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite3.Body = ModAPI.LoadSprite("Textures/Roadroller/Orange/Body.png");
                        CarSprite3.Background = ModAPI.LoadSprite("Textures/Roadroller/Orange/Background.png");
                        CarSprite3.FrontDoor = ModAPI.LoadSprite("Textures/Roadroller/Orange/Door.png");
                        CarSprite3.Bonnet = ModAPI.LoadSprite("Textures/Roadroller/Orange/Bonnet.png");

                        var CarSprite4 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite4.Body = ModAPI.LoadSprite("Textures/Roadroller/Rusty/Body.png");
                        CarSprite4.Background = ModAPI.LoadSprite("Textures/Roadroller/Rusty/Background.png");
                        CarSprite4.FrontDoor = ModAPI.LoadSprite("Textures/Roadroller/Rusty/Door.png");
                        CarSprite4.Bonnet = ModAPI.LoadSprite("Textures/Roadroller/Rusty/Bonnet.png");

                        var CarSprite5 = new RandomCarTextureBehaviour.CarSprites();
                        CarSprite5.Body = ModAPI.LoadSprite("Textures/Roadroller/Snowy/Body.png");
                        CarSprite5.Background = ModAPI.LoadSprite("Textures/Roadroller/Snowy/Background.png");
                        CarSprite5.FrontDoor = ModAPI.LoadSprite("Textures/Roadroller/Snowy/Door.png");
                        CarSprite5.Bonnet = ModAPI.LoadSprite("Textures/Roadroller/Snowy/Bonnet.png");                    

                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>().sortingOrder = 5;
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().chosenIndex = UnityEngine.Random.Range(0, 5);
                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[] 
                        {
                            CarSprite1,
                            CarSprite2,
                            CarSprite3,
                            CarSprite4,
                            CarSprite5
                        };                      
                //Settings
                        if(firstSpawn)
                        {
                            GameObject chair1 = new GameObject("Chair 1");
                            chair1.transform.parent = Instance.transform;
                            chair1.transform.localScale = Vector3.one;
                            chair1.transform.localPosition = new Vector3(-0.256f, 0.056f);
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = chair1;

                            GameObject Bodyup = new GameObject("Body2");
                            Bodyup.transform.parent = Instance.transform;
                            Bodyup.transform.localScale = Vector3.one;
                            Bodyup.transform.localPosition = new Vector3(-1.34285f, 1.0141f); 
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = Bodyup;

                            GameObject Lampff = new GameObject("Lamp");
                            Lampff.transform.parent = Instance.transform;
                            Lampff.transform.localScale = Vector3.one;
                            Lampff.transform.localPosition = new Vector3(2.7003f, -0.6436f); 
                            Instance.AddComponent<ObjectSerialisationHelper>().SerialisationObject = Lampff;
                        }
                    //Body      
                        if (firstSpawn)
                        {
                            body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = MotorSpeed;
                            body.gameObject.GetComponent<CarBehaviour>().WaterProof = WaterProof; 
                        }                                       
                        body.GetComponent<PolygonCollider2D>().pathCount = 2;
                        
                        body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(2.7951932f,-0.709461331f),
                            new Vector2(0.754169703f,-0.714874983f),  
                            new Vector2(0.839129925f,-0.32577914f),  
                            new Vector2(1.11050236f,-0.0859619975f),  
                            new Vector2(1.10548794f,0.0751149654f),  
                            new Vector2(0.934939682f,0.0603026748f),  
                            new Vector2(0.922068715f,1.49682581f),  
                            new Vector2(1.19047606f,1.66316593f),  
                            new Vector2(1.10769784f,1.84907091f),  
                            new Vector2(-1.1404984f,1.83109808f),
                            new Vector2(-1.20491207f,1.62361598f),
                            new Vector2(-0.972346663f,1.48676133f),  
                            new Vector2(-0.979294419f,0.805262327f),  
                            new Vector2(-1.45116949f,0.579909027f),  
                            new Vector2(-1.70350659f,0.241274953f),  
                            new Vector2(-2.19937778f,-0.00113485008f),  
                            new Vector2(-2.39267015f,-0.167541683f),  
                            new Vector2(-2.53399587f,-0.381219834f),  
                            new Vector2(-2.70220041f,-0.985095024f),  
                            new Vector2(-2.79982591f,-1.02423334f),
                            new Vector2(-2.80363297f,-1.2055614f),
                            new Vector2(-2.5525589f,-1.20469368f),  
                            new Vector2(-2.19107175f,-1.19901979f),  
                            new Vector2(-2.12617612f,-0.878451526f),  
                            new Vector2(-1.78801632f,-0.528783619f),  
                            new Vector2(-0.723331869f,-0.48689276f),  
                            new Vector2(-0.684034765f,-0.601267338f),  
                            new Vector2(-0.374614179f,-0.592255592f),  
                            new Vector2(-0.353236079f,-1.08832479f),  
                            new Vector2(2.71553254f,-1.08814991f)                     
                        });
                        body.gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
                        {
                            new Vector2(-0.888522089f,1.5546174f),  
                            new Vector2(-0.878435135f,0.43902117f),  
                            new Vector2(-0.627556264f,-0.519756794f),  
                            new Vector2(0.533927321f,-0.514439225f),  
                            new Vector2(0.827720702f,-0.0468912721f),  
                            new Vector2(0.832945585f,1.54831314f) 
                        });
                        Instance.transform.GetChild(0).GetChild(0).localPosition = Vector3.zero;
                        foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            {
                                GameObject.Destroy(boxCollider);
                            }
                    //Wheels
                        WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        if(firstSpawn)
                        {
                            wheels[0].connectedBody.gameObject.transform.localPosition = new Vector2(1.669f, -0.9f);
                        }  
                        wheels[0].anchor = new Vector2(1.669f, -0.9f);
                        wheels[0].suspension = new JointSuspension2D()
                        {
                            frequency = 35f,
                            angle = 90f,
                            dampingRatio = 0f
                        };
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel1;
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 3;
                        wheels[0].connectedBody.gameObject.GetComponent<PhysicalBehaviour>().InitialMass = 80;
                        wheels[0].connectedBody.gameObject.GetComponent<PhysicalBehaviour>().TrueInitialMass = 90;
                        wheels[0].connectedBody.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Concrete");
                        wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.9285714f;
                        
                        if(firstSpawn)
                        {
                            wheels[1].connectedBody.gameObject.transform.localPosition = new Vector2(-1.5002f, -1.1858f);
                        }  
                        wheels[1].anchor = new Vector2(-1.5002f, -1.1858f); //-0.8586
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = Wheel2;
                        wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.6428571f;
                    //Front Door
                        var frontDoor = Instance.transform.GetChild(5);
                        if(firstSpawn)
                        {
                            frontDoor.localPosition = new Vector3(-0.25714f, 0.51429f);
                        }                       
                        Instance.transform.GetChild(5).gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.714285731f,1.11428571f),
                            new Vector2(-0.712338448f,-0.0786612034f),
                            new Vector2(-0.421453029f,-1.11428571f),
                            new Vector2(0.59872359f,-1.11233842f),
                            new Vector2(0.712550998f,-0.456690103f),
                            new Vector2(0.714285731f,1.11428571f)
                        });
                        frontDoor.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(0.668f, 0f);
                        frontDoor.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 6;
                        frontDoor.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";  
                    //Back Door
                        var backDoor = Instance.transform.GetChild(6);
                        if(firstSpawn)
                        {
                            backDoor.localPosition = new Vector3(2.4285f, 0.12855f);
                        }
                        backDoor.gameObject.AddComponent<BoxCollider2D>().size = new Vector2(0.6285715f, 2.457143f);
                        backDoor.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.33f, 0f);
                        GameObject.Destroy(backDoor.gameObject.GetComponent<PolygonCollider2D>());
                        Instance.transform.GetChild(6).gameObject.SetActive(false);
                    //Bonnet
                        var bonnet = Instance.transform.GetChild(3);
                        bonnet.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        bonnet.gameObject.GetComponent<SpriteRenderer>().sortingOrder = -3;
                        //bonnet.gameObject.GetComponent<SpriteRenderer>().sortingOrder = wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        bonnet.gameObject.GetComponent<FixedJoint2D>().breakForce = 300f;
                        bonnet.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(0.3281f, 0.2996f);
                        var limits = new JointAngleLimits2D();
                        limits.min = 65;
                        limits.max = 0;
                        bonnet.gameObject.GetComponent<HingeJoint2D>().limits = limits;
                        if(firstSpawn)
                        {
                            bonnet.localPosition = new Vector3(-2.242f, -0.203f);
                        }
                        bonnet.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(0.269399315f,0.312141925f),
                            new Vector2(0.0229640007f,0.195811376f),
                            new Vector2(-0.126249552f,0.0596507043f),
                            new Vector2(-0.274755716f,-0.148065522f),
                            new Vector2(-0.302155256f,-0.256331474f),
                            new Vector2(-0.328064203f,-0.257774532f),
                            new Vector2(-0.328832626f,-0.285708934f),
                            new Vector2(-0.300384521f,-0.286672115f),
                            new Vector2(-0.299744725f,-0.314285725f),
                            new Vector2(-0.242114589f,-0.314285725f),
                            new Vector2(-0.213366508f,-0.233014286f),
                            new Vector2(-0.0965764523f,-0.0249013752f),
                            new Vector2(0.0214059353f,0.121877357f),
                            new Vector2(0.146088839f,0.195813805f),
                            new Vector2(0.324811459f,0.252640307f),
                            new Vector2(0.324811459f,0.252640307f)
                        });
                    //Boot
                        Instance.transform.GetChild(4).gameObject.SetActive(false);
                    //Engine
                        var engine = Instance.transform.GetChild(7);
                        engine.localScale = new Vector3(0.9f, 0.9f);
                        if(firstSpawn)
                        {
                            engine.localPosition = new Vector3(-1.558f, -0.354f);
                        }
                    //Gas Tank
                        var GasTank = Instance.transform.GetChild(8);
                        GasTank.localScale = new Vector3(0.9f, 0.9f);
                        if(firstSpawn)
                        {
                            GasTank.localPosition = new Vector3(-0.576f, -0.791f);
                        }
                        GameObject.Destroy(GasTank.gameObject.GetComponent<BoxCollider2D>());
                        Instance.transform.GetChild(8).gameObject.AddComponent<BoxCollider2D>();
                        //Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vechicle/Tractor/Gas Tank.png");
                        //Instance.transform.GetChild(8).gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
                    //Chair
                        ObjectSerialisationHelper[] objectSerialisationHelpers = Instance.GetComponents<ObjectSerialisationHelper>();
                        objectSerialisationHelpers[0].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer chair1Renderer = gameObject.AddComponent<SpriteRenderer>();
                            chair1Renderer.sprite = Chair;
                            chair1Renderer.sortingLayerName = "Default";
                            chair1Renderer.sortingOrder = 4;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            //chair1.AddComponent<BoxCollider2D>();
                            gameObject.AddComponent<Rigidbody2D>().mass = 1f;
                            FixedJoint2D fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                            fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                            fixedJoint.breakForce = 4000f;
                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            gameObject.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            {
                                new Vector2(-0.371428579f,0.571428597f),
                                new Vector2(-0.250261158f,-0.571160555f),
                                new Vector2(0.0768283159f,-0.571428597f),
                                new Vector2(0.123448327f,-0.309277505f),
                                new Vector2(0.28686288f,-0.254461765f),
                                new Vector2(0.286862969f,-0.0586752892f),
                                new Vector2(-0.112807915f,-0.0586890578f),
                                new Vector2(-0.142857149f,0.571428597f)
                            });
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });
                    //Tube
                        objectSerialisationHelpers[1].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer BodyupRenderer = gameObject.AddComponent<SpriteRenderer>();
                            BodyupRenderer.sprite = Tube;
                            BodyupRenderer.sortingLayerName = "Foreground";
                            BodyupRenderer.sortingOrder = 6;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            gameObject.AddComponent<Rigidbody2D>().mass = 3f;
                            FixedJoint2D fixedJointBodyup = gameObject.AddComponent<FixedJoint2D>();
                            fixedJointBodyup.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                            fixedJointBodyup.breakForce = 3000f;
                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            var Body2Collider = gameObject.AddComponent<PolygonCollider2D>();
                            Body2Collider.pathCount = 1;
                            Body2Collider.SetPath(0, new Vector2[]
                            {
                                new Vector2(0.200000003f,-0.528571427f),
                                new Vector2(0.201300502f,0.0743412971f), 
                                new Vector2(-0.0567095727f,0.0748302341f), 
                                new Vector2(-0.0562729836f,0.441311836f),       
                                new Vector2(-0.00480055809f,0.463728786f), 
                                new Vector2(0.00167798996f,0.528571486f), 
                                new Vector2(-0.200000003f,0.528571427f), 
                                new Vector2(-0.200361729f,0.470871329f), 
                                new Vector2(-0.140716791f,0.43632102f), 
                                new Vector2(-0.150383353f,-0.0173110366f), 
                                new Vector2(0.120381355f,-0.012593627f), 
                                new Vector2(0.113251373f,-0.529860497f)
                            });
                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });
                    //Lamp
                        objectSerialisationHelpers[2].InstantiateOverride = ((gameObject) =>
                        {
                            SpriteRenderer LampRenderer = gameObject.AddComponent<SpriteRenderer>();
                            LampRenderer.sprite = Lamp;
                            LampRenderer.sortingLayerName = "Foreground";
                            LampRenderer.sortingOrder = 2;
                            gameObject.layer = LayerMask.NameToLayer("Objects");
                            gameObject.AddComponent<Rigidbody2D>().mass = 3f;
                            FixedJoint2D fixedJointLamp = gameObject.AddComponent<FixedJoint2D>();
                            fixedJointLamp.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                            fixedJointLamp.breakForce = 3000f;
                            gameObject.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
                            gameObject.AddComponent<PolygonCollider2D>();

                            NoCollide noCollide = Instance.GetComponent<NoCollide>();
                            noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                            noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        });
                    //SerialisationSettings
                        if(firstSpawn)
                        {
                            objectSerialisationHelpers[0].InstantiateOverride(objectSerialisationHelpers[0].SerialisationObject);
                            objectSerialisationHelpers[1].InstantiateOverride(objectSerialisationHelpers[1].SerialisationObject);
                            objectSerialisationHelpers[2].InstantiateOverride(objectSerialisationHelpers[2].SerialisationObject);
                        } 
                //                                 
                    }
                }
            );      
	    }
    }
    public class CarWheelsBehaviour : MonoBehaviour
    {
        private void OnJointBreak2D(Joint2D joint)
        {
            if (Wheels.Contains(joint))
            {
                joint.connectedBody.transform.parent = transform.parent;
            }
        }

        [SkipSerialisation]
        public WheelJoint2D[] Wheels = new WheelJoint2D[0];
    }
    public class ObjectSerialisationHelper : MonoBehaviour
    {
        private void OnBeforeSerialise()
        {
            originalName = SerialisationObject.name;

            parentName = SerialisationObject.transform.parent.gameObject.name;

            temperature = SerialisationObject.GetComponent<PhysicalBehaviour>().Temperature;

            if (SerialisationObject.GetComponent<FreezeBehaviour>())
            {
                frezee = true;
            }
            else
            {
                frezee = false;
            }

            if (SerialisationObject.layer == 10)
            {
                disabledCollision = true;
            }
            else
            {
                disabledCollision = false;
            }

            if (SerialisationObject.GetComponent<PhysicalBehaviour>().IsWeightless)
            {
                makeWeightless = true;
            }
            else
            {
                makeWeightless = false;
            }

            if (SerialisationObject.GetComponent<RandomCarTextureBehaviour>())
            {
                carTextureIndex = SerialisationObject.GetComponent<RandomCarTextureBehaviour>().chosenIndex;
            }

            jointHelpers = SerialisationObject.GetComponents<JointSerialisationHelper>();
            List<bool> jointBrokenList = new List<bool>();
            for (int i = 0; i < jointHelpers.Length; i++)
            {
                jointBrokenList.Add(jointHelpers[i].Broken);
            }
            jointBroken = jointBrokenList.ToArray();

            if (SerialisationObject.GetComponent<CarBehaviour>())
            {
                wheelJointState = SerialisationObject.GetComponent<CarBehaviour>().WheelJointState;
            }

            originalScale = transform.localScale;

            transformPrototype = new TransformPrototype(SerialisationObject.transform.localPosition, SerialisationObject.transform.eulerAngles.z, SerialisationObject.transform.localScale);
        }
        private void OnAfterDeserialise()
        {
            if (!SerialisationObject)
            {
                SerialisationObject = new GameObject(originalName);
                if (gameObject.name == parentName)
                {
                    SerialisationObject.transform.parent = transform;
                }
                else
                {
                    SerialisationObject.transform.parent = transform.Find(parentName);
                }
            }
            else
            {
                SerialisationObject.name = originalName;
            }

            SerialisationObject.transform.position = SerialisationObject.transform.parent.TransformPoint(transformPrototype.RelativePosition);
            SerialisationObject.transform.eulerAngles = new Vector3(0f, 0f, (transform.localScale == originalScale) ? transformPrototype.RelativeRotation + gameObject.transform.eulerAngles.z : -transformPrototype.RelativeRotation - gameObject.transform.eulerAngles.z);
            SerialisationObject.transform.localScale = transformPrototype.LocalScale;

            InstantiateOverride(SerialisationObject);

            if (SerialisationObject.GetComponent<CarBehaviour>())
            {
                SerialisationObject.GetComponent<CarBehaviour>().WheelJointState = wheelJointState;
            }

            SerialisationObject.GetComponent<PhysicalBehaviour>().Temperature = temperature;

            if (frezee)
            {
                SerialisationObject.AddComponent<FreezeBehaviour>();
            }

            if (disabledCollision)
            {
                SerialisationObject.layer = 10;
            }

            if (makeWeightless)
            {
                SerialisationObject.GetComponent<PhysicalBehaviour>().IsWeightless = true;
            }

            if (SerialisationObject.GetComponent<RandomCarTextureBehaviour>())
            {
                SerialisationObject.GetComponent<RandomCarTextureBehaviour>().chosenIndex = carTextureIndex;
            }

            jointHelpers = SerialisationObject.GetComponents<JointSerialisationHelper>();
            for (int i = 0; i < jointHelpers.Length; i++)
            {
                if (jointBroken[i])
                {
                    jointHelpers[i].SendMessage("OnJointBreak2D", jointHelpers[i].Joint);
                    Destroy(jointHelpers[i].Joint);
                }
            }
        }

        public bool frezee;
        public bool disabledCollision;
        public bool makeWeightless;
        public bool[] jointBroken;
        public bool[] wheelJointState;
        [SkipSerialisation]
        public GameObject SerialisationObject;
        public TransformPrototype transformPrototype;
        private JointSerialisationHelper[] jointHelpers;
        [SkipSerialisation]
        public Action<GameObject> InstantiateOverride;
        public Vector3 originalScale;
        public string originalName;
        public string parentName;
        public float temperature;
        public int carTextureIndex;
    }
    public class CarOpticsBehaviour : MonoBehaviour
    {
        private void Start()
        {
            phys = gameObject.GetComponent<PhysicalBehaviour>();
            Car = gameObject.GetComponent<CarBehaviour>();
            for(int i = 0; i < Headlights.Length; i++)
            {
                Headlights[i].SetActive(false);
            }
            if(ReversingLamp != null)
            {
                ReversingLamp.SetActive(false);
            }
            if(firstSpawn)
            {
                startMotorSpeed = Car.MotorSpeed;
            }
            phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("cruiseControl", "Set speed limit", "Sets speed limit", new UnityAction[1]
            {
                () =>
                {
                    DialogBox dialog = null;
                    dialog = DialogBoxManager.TextEntry("Set the speed limit\n<color=green><size=26>Currently: " + Mathf.Abs(Car.MotorSpeed).ToString() + "</size></color>", "Speed limit", new DialogButton[]
                    {
                        new DialogButton("Apply", true, new UnityAction[1]
                        {
                            () =>
                            {
                                float speedLimit;
                                if(float.TryParse(dialog.EnteredText, out speedLimit))
                                {
                                    if(speedLimit > 0f)
                                    {
                                        if(speedLimit >= Mathf.Abs(startMotorSpeed))
                                        {
                                            Car.MotorSpeed = (Car.MotorSpeed > 0f) ? Mathf.Abs(startMotorSpeed) : startMotorSpeed;
                                            return;
                                        }
                                        if(Car.MotorSpeed > 0f)
                                        {
                                            Car.MotorSpeed = speedLimit;
                                        }
                                        else
                                        {
                                            Car.MotorSpeed = -speedLimit;
                                        }
                                    }
                                    else
                                    {
                                        if(speedLimit <= startMotorSpeed)
                                        {
                                            Car.MotorSpeed = (Car.MotorSpeed > 0f) ? Mathf.Abs(startMotorSpeed) : startMotorSpeed;
                                            return;
                                        }
                                        if(Car.MotorSpeed > 0f)
                                        {
                                            Car.MotorSpeed = Mathf.Abs(speedLimit);
                                        }
                                        else
                                        {
                                            Car.MotorSpeed = speedLimit;
                                        }
                                    }
                                }
                            }
                        }),
                        new DialogButton("Off", true, new UnityAction[1]
                        {
                            () =>
                            {
                                Car.MotorSpeed = startMotorSpeed;
                            }
                        }),
                        new DialogButton("Cancel", true, () => dialog.Close())
                    });
                }
            }));
            phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("toggleHeadlights", () =>
            {
                if(!HeadlightsActivated)
                {
                    return "Enable headlights";
                }
                return "Disable headlights";
            }, "Toggles headlights", new UnityAction[1]
            {
                () =>
                {
                    HeadlightsActivated = !HeadlightsActivated;
                }
            }));
            if(TurnSignals.Length != 0)
            {
                phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("toggleTurnSignals", (() =>
                {
                    if(!TurnSignalsActivated)
                    {
                        return "Enable turn signals";
                    }
                    return "Disable turn signals";
                }), "Toggles turn signals", new UnityAction[1]
                {
                    () =>
                    {
                        TurnSignalsActivated = !TurnSignalsActivated;
                        UpdateActivation();
                    }
                }));
            }
            if(FailedEngineStartup)
            {
                carAudioSources = Car.audioSourcePosition.GetComponents<AudioSource>();
                failedEngineStartupSource = Car.audioSourcePosition.gameObject.AddComponent<AudioSource>();
                failedEngineStartupSource.spread = 0f;
                failedEngineStartupSource.volume = 1f;
                failedEngineStartupSource.minDistance = 10f;
                failedEngineStartupSource.spatialBlend = 1f;
                failedEngineStartupSource.dopplerLevel = 1f;
                gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
            }
            UpdateActivation();
            firstSpawn = false;
        }
        private void Use()
        {
            if(FailedEngineStartup)
            {
                if(Car.Activated)
                {
                    if((double)UnityEngine.Random.value > FailedEngineStartupChance)
                    {
                        carAudioSources[0].Stop();
                        carAudioSources[1].Stop();
                        Car.Activated = false;
                        failedEngineStartupSource.PlayOneShot(FailedEngineStartupSound, 1f);
                    }
                }
            }
        }
        private void Update()
        {
            for(int i = 0; i < Headlights.Length; i++)
            {
                if(HeadlightsActivated)
                {
                    Headlights[i].SetActive(true);
                }
                if(!HeadlightsActivated)
                {
                    Headlights[i].SetActive(false);
                }
            }
            if(ReversingLamp != null)
            {
                if(Car.MotorSpeed > 0 && Car.Activated && !ReversingLampActivated)
                {
                    ReversingLampActivated = true;
                    ReversingLamp.SetActive(true);
                }
                if(Car.MotorSpeed < 0 && ReversingLampActivated || !Car.Activated)
                {
                    ReversingLampActivated = false;
                    ReversingLamp.SetActive(false);
                }
            }
        }
        private void UpdateActivation()
        {
            if(TurnSignals.Length != 0)
            {
                if(TurnSignalsActivated)
                {
                    StopAllCoroutines();
                    StartCoroutine(Blink());
                }
                else
                {
                    for(int i = 0; i < TurnSignals.Length; i++)
                    {
                        TurnSignals[i].SetActive(false);
                    }
                    StopAllCoroutines();
                }
            }
        }
        private void OnCollisionEnter2D(Collision2D collision)
        {
            if(ActivateTurnSignalsOnCollision && TurnSignals.Length != 0)
            {
                if(collision.GetContact(0).normalImpulse > BreakingThreshold)
                {
                    TurnSignalsActivated = true;
                    UpdateActivation();
                }
            }
        }
        private IEnumerator Blink()
        {
            while(TurnSignalsActivated)
            {
                yield return new WaitForSeconds(0.3f);
                for(int i = 0; i < TurnSignals.Length; i++)
                {
                    TurnSignals[i].SetActive(true);
                }
                yield return new WaitForSeconds(0.3f);
                for(int i = 0; i < TurnSignals.Length; i++)
                {
                    TurnSignals[i].SetActive(false);
                }
            }
        }

        public bool firstSpawn = true;
        public bool HeadlightsActivated;
        public bool TurnSignalsActivated;
        public bool ReversingLampActivated;
        public bool ActivateTurnSignalsOnCollision;
        public bool FailedEngineStartup;
        [SkipSerialisation]
        public GameObject[] Headlights = new GameObject[0];
        [SkipSerialisation]
        public GameObject[] TurnSignals = new GameObject[0];
        [SkipSerialisation]
        public GameObject ReversingLamp;
        private PhysicalBehaviour phys;
        private AudioSource[] carAudioSources;
        private AudioSource failedEngineStartupSource;
        [SkipSerialisation]
        public CarBehaviour Car;
        [SkipSerialisation]
        public AudioClip FailedEngineStartupSound;
        public float BreakingThreshold = 20f;
        public float startMotorSpeed;
        public double FailedEngineStartupChance = 0.8d;
    }
    public class RandomCarTextureChildBehaviour : MonoBehaviour
    {
        private void Start()
        {
            phys = gameObject.GetComponent<PhysicalBehaviour>();
            renderer = gameObject.GetComponent<SpriteRenderer>();
            randomCarTextures = transform.root.gameObject.GetComponentInChildren<RandomCarTextureBehaviour>();
            if(randomCarTextures)
            {
                randomCarTextures.OnAfterChange.AddListener(new UnityAction(SyncSprite));
                randomCarTextures.OnAfterChange.Invoke();
            }
        }
        private void SyncSprite()
        {
            renderer.sprite = Sprites[randomCarTextures.chosenIndex];
            if(phys)
            {
                phys.RefreshOutline();
            }
        }

        private PhysicalBehaviour phys;
        private SpriteRenderer renderer;
        private RandomCarTextureBehaviour randomCarTextures;
        public Sprite[] Sprites = new Sprite[0];
    }
    public class TowbarBehaviour : MonoBehaviour
    {
        public interface IOnConnected
        {
            void OnConnected(TowbarBehaviour otherTowbar);
        }
        public interface IOnDisconnected
        {
            void OnDisconnected();
        }
        private void Start()
        {
            gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("disconnect", "Disconnect", "Disconnect", new UnityAction[]
            {
                delegate()
                {
                    if(fixedJoint)
                    {
                        Disconnect();
                    }
                    else
                    {
                        connectedTowbar.Disconnect();
                    }
                }
            })
            {
                Condition = (() => connectedTowbar)
            });
        }
        private void OnCollisionEnter2D(Collision2D collision)
        {
            if(collision.gameObject.GetComponent<TowbarBehaviour>() && !connectedTowbar && !collision.gameObject.GetComponent<TowbarBehaviour>().connectedTowbar && collision.gameObject.GetComponent<TowbarBehaviour>().IsTrailerTowbar != IsTrailerTowbar)
            {
                connectedTowbar = collision.gameObject.GetComponent<TowbarBehaviour>();
                collision.gameObject.GetComponent<TowbarBehaviour>().connectedTowbar = gameObject.GetComponent<TowbarBehaviour>();
                fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                fixedJoint.breakForce = 40000f;
                fixedJoint.connectedBody = collision.gameObject.GetComponent<Rigidbody2D>();
                fixedJoint.anchor = Anchor;
                fixedJoint.frequency = 10f;
                fixedJoint.dampingRatio = 1f;
                noCollide = gameObject.AddComponent<NoCollide>();
                noCollide.NoCollideSetA = GetComponents<Collider2D>();
                noCollide.NoCollideSetB = collision.gameObject.GetComponents<Collider2D>();
                transform.root.gameObject.BroadcastMessage("OnConnected", connectedTowbar, SendMessageOptions.DontRequireReceiver);
                collision.transform.root.gameObject.BroadcastMessage("OnConnected", this, SendMessageOptions.DontRequireReceiver);
            }
        }
        private void OnJointBreak2D(Joint2D joint)
        {
            if (noCollide)
            {
                Disconnect();
            }
            else
            {
                connectedTowbar.Disconnect();
            }
        }
        public void Disconnect()
        {
            transform.root.gameObject.BroadcastMessage("OnDisconnected", connectedTowbar, SendMessageOptions.DontRequireReceiver);
            connectedTowbar.transform.root.gameObject.BroadcastMessage("OnDisconnected", this, SendMessageOptions.DontRequireReceiver);
            Destroy(fixedJoint);
            Destroy(noCollide, 2.5f);
            connectedTowbar.connectedTowbar = null;
            connectedTowbar = null;
        }

        public bool IsTrailerTowbar = false;
        [SkipSerialisation]
        public TowbarBehaviour connectedTowbar;
        [SkipSerialisation]
        public FixedJoint2D fixedJoint;
        [SkipSerialisation]
        public NoCollide noCollide;
        [SkipSerialisation]
        public Vector2 Anchor = Vector2.zero;
    }
    public class TrailerBehaviour : MonoBehaviour, TowbarBehaviour.IOnConnected, TowbarBehaviour.IOnDisconnected
    {
        private void Start()
        {
            phys = gameObject.GetComponent<PhysicalBehaviour>();
            phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("disconnect", "Disconnect", "Disconnect", new UnityAction[1]
            {
                () =>
                {
                    if (TowbarBehaviour.fixedJoint)
                    {
                        TowbarBehaviour.Disconnect();
                    }
                    else
                    {
                        TowbarBehaviour.connectedTowbar.Disconnect();
                    }
                }
            }));
            StartCoroutine(SupportFoot.Move(1f));
        }
        public void OnConnected(TowbarBehaviour towbarBehaviour)
        {
            carBehaviour = towbarBehaviour.transform.root.GetComponentInChildren<CarBehaviour>();
            List<WheelJoint2D> wheelList = carBehaviour.WheelJoints.ToList();
            wheelList.AddRange(Wheels);
            carBehaviour.WheelJoints = wheelList.ToArray();
            StartCoroutine(SupportFoot.Move(-1f));
        }
        public void OnDisconnected()
        {
            List<WheelJoint2D> wheelList = carBehaviour.WheelJoints.ToList();
            foreach (WheelJoint2D wheel in Wheels)
            {
                float maxMotorTorque = wheel.motor.maxMotorTorque;
                wheel.motor = new JointMotor2D
                {
                    motorSpeed = 0f,
                    maxMotorTorque = maxMotorTorque
                };
                wheelList.Remove(wheel);
            }
            carBehaviour.WheelJoints = wheelList.ToArray();
            carBehaviour = null;
            StartCoroutine(SupportFoot.Move(1f));
        }
        private void OnJointBreak2D(Joint2D joint)
        {
            if (!Wheels.Contains(joint))
            {
                return;
            }
            List<WheelJoint2D> wheels = Wheels.ToList();
            wheels.Remove(joint as WheelJoint2D);
            Wheels = wheels.ToArray();
            if(carBehaviour != null)
            {
                List<WheelJoint2D> wheelList = carBehaviour.WheelJoints.ToList();
                wheelList.Remove(joint as WheelJoint2D);
                carBehaviour.WheelJoints = wheelList.ToArray();
            }
        }

        private PhysicalBehaviour phys;
        [SkipSerialisation]
        private CarBehaviour carBehaviour;
        [SkipSerialisation]
        public TowbarBehaviour TowbarBehaviour;
        [SkipSerialisation]
        public WheelJoint2D[] Wheels;
        [SkipSerialisation]
        public SupportFootBehaviour SupportFoot;
    }
    public class SupportFootBehaviour : MonoBehaviour
    {
        private void Start()
        {
            originalLimits = SliderJoint.limits;
            UpdateLimits();
        }
        public IEnumerator Move(float direction)
        {
            JointLimitState2D limitToWaitFor = (direction > 0f) ? JointLimitState2D.UpperLimit : JointLimitState2D.LowerLimit;
            SetMotorSpeed(direction * Mathf.Abs(transform.localScale.x));
            yield return new WaitUntil(() => SliderJoint.limitState == limitToWaitFor);
            SetMotorSpeed(0f);
            yield break;
        }
        private void Update()
        {
            UpdateLimits();
        }
        private void UpdateLimits()
        {
            JointTranslationLimits2D limits = default;
            float num = Mathf.Abs(transform.localScale.x);
            limits.max = originalLimits.max * num;
            limits.min = originalLimits.min * num;
            SliderJoint.limits = limits;
        }
        private void SetMotorSpeed(float speed)
        {
            JointMotor2D motor = SliderJoint.motor;
            motor.motorSpeed = speed * 0.5f;
            SliderJoint.motor = motor;
        }

        [SkipSerialisation]
        public SliderJoint2D SliderJoint;
        private JointTranslationLimits2D originalLimits;
    }
    public class BlinkerBehaviour : MonoBehaviour
    {
        private void Start()
        {
            Glow1.SetActive(false);
            Glow2.SetActive(false);
            damagableMachinery = GetComponent<DamagableMachineryBehaviour>();
            damagableMachinery.OnDamaged = new UnityEvent();
            damagableMachinery.OnDamaged.AddListener(() =>
            {
                UpdateActivation();
            });
            UpdateActivation();
        }
        private void Use()
        {
            Activated = !Activated;
            UpdateActivation();
        }
        private void UpdateActivation()
        {
            if(Activated && !damagableMachinery.Destroyed)
            {
                Audio.Play();
                StartCoroutine(Blink(Delay));
            }
            else
            {
                Audio.Stop();
                StopAllCoroutines();
                Glow1.SetActive(false);
                Glow2.SetActive(false);
            }
            if(damagableMachinery.Destroyed)
            {
                Audio.Stop();
                StopAllCoroutines();
                Glow1.SetActive(false);
                Glow2.SetActive(false);
                Activated = false;
            }
        }
        private IEnumerator Blink(float delay)
        {
            Glow1.SetActive(true);
            while(Activated)
            {
                yield return new WaitForSeconds(delay);
                Glow1.SetActive(false);
                Glow2.SetActive(true);
                yield return new WaitForSeconds(delay);
                Glow1.SetActive(true);
                Glow2.SetActive(false);
            }
        }

        public bool Activated;
        public GameObject Glow1;
        public GameObject Glow2;
        public AudioSource Audio;
        private DamagableMachineryBehaviour damagableMachinery;
        public float Delay;
    }
}